/*
 * Title: Display the annotated BASIC Listing (1)
 *
 *  Listing of D:\Dev\BasicGames\Translator\basic\Maze.bas: 
 *
               +---- Routine IDs (Empty field=Inaccessible code, A=Main program).
               | +-- Target status (G-GOSUB, T-GOTO, B-Both GOSUB and GOTO)
      Program  | |
      Address  v v Original BASIC statement
    ---------- - - ------------------------------------------------------------------------------
    0x00cdbaf8 A   01000 PRINT"D A T A L I N E   S Y S T E M S   L T D."
    0x00cdbbc0 A   01010 PRINT"BASIC LIBRARY--'AMAZES'--19-JUL-70"
    0x00cdbbf8 A   01020 REM
    0x00cdbca0 A   01030 REM  DESCRIPTION--CONSTRUCTS A DIFFERENT MAZE EVERY TIME
    0x00cdbd50 A   01040 REM  IT IS RUN WITH ONLY ONE SOLUTION. THE USER CHOOSES THE 
    0x00cdbdbc A   01050 REM  DIMENSION OF THE MAZE.
    0x00cdbe7c A   01060 REM  *  *  *  *  *  *   MAIN PROGRAM   *  *  *  *  *  *  *  *  *  *  *
    0x00cdbebc A   01070 REM 
    0x00cdbf18 A   01080 RANDOMIZE
    0x00cdcc60 A   01090 DIM W(25,103), V(25,103)
    0x00cdcd78 A   01100 PRINT "THIS PROGRAM WILL PRINT OUT A DIFFERENT MAZE EVERY TIME IT"
    0x00cdce98 A   01110 PRINT "IS RUN AND GUARANTEES ONLY ONE PATH THROUGH.  YOU CAN CHOOSE"
    0x00cdcfb4 A   01120 PRINT "THE DIMENSIONS OF THE MAZE. I.E. THE NUMBER OF SQUARES WIDE"
    0x00cdd0c8 A   01130 PRINT "AND THE NUMBER OF SQUARES LONG.  A 23 BY 25 MAZE IS THE "
    0x00cdd1a4 A   01140 PRINT "MAXIMUM, BUT ANY DIMENSIONS UP TO THESE LIMITS ARE OK."
    0x00cdd204 A   01150 PRINT
    0x00cdd2e0 A T 01160 PRINT "WHAT ARE YOUR WIDTH AND LENGTH";
    0x00cdd3f4 A   01170 INPUT H,V
    0x00cdd43c A   01180 PRINT
    0x00cd1948 A   01190 IF H<>1 THEN 1240
    0x00cdd5cc A   01200 IF V<>1 THEN 1240
    0x00cdd6cc A   01210 PRINT "MEANINGLESS DIMENSIONS, TRY AGAIN."
    0x00cdd70c A   01220 PRINT
    0x00cdd748 A   01230 GO TO 1160
    0x00cdd77c A T 01240 PRINT
    0x00cdd7bc A   01250 PRINT
    0x00cdd8c8 A   01260 LET Q = 0
    0x00cdd9c8 A   01270 LET Z = 0
    0x00cdd9fc A   01280 
    0x00cdda64 A   01290 
    0x00cddac4 A   01300 REM                           STEPS 1900 THRU 3200 PICK THE
    0x00cddb68 A   01310 REM                           SQUARE IN WHICH TO START.
    0x00cddba4 A   01320 
    0x00cddce8 A   01330 
    0x00cddf24 A   01340 LET X = INT(RND*H+1)
    0x00cde060 A   01350 FOR I = 1 TO H
    0x00cde0fc A   01360  IF I = X THEN 1390
    0x00cde1d8 A   01370  PRINT ":--";
    0x00cde21c A   01380  GOTO 1400
    0x00cde2d0 A T 01390  PRINT ":  ";
    0x00cde324 A T 01400 NEXT I
    0x00cde3dc A   01410 PRINT ":"
    0x00cde4ec A   01420 LET C = 1
    0x00cde604 A   01430 LET W(X,1) = C
    0x00cde70c A   01440 LET C = C+1
    0x00cde7dc A   01450 LET R = X
    0x00cde8e4 A   01460 LET S = 1
    0x00cde918 A   01470 GOTO 1750
    0x00cde948     01480 
    0x00cde9b4     01490 
    0x00cdea18 A   01500 REM                           STEPS 4900 THRU 5700 LOOK FOR THE
    0x00cdeac8 A   01510 REM                           SQUARE IN WHICH TO START A NEW 
    0x00cdeb80 A   01520 REM                           PATH WHEN THE OLD ONE GETS BLOCKED.
    0x00cdec38 A   01530 REM                           THE LINES ARE SCANNED FOR A SQUARE
    0x00cdecf0 A   01540 REM                           WHICH HAS ALREADY BEEN USED BUT IS
    0x00cded98 A   01550 REM                           ADJACENT TO AN OPEN SQUARE.
    0x00cdedd4     01560 
    0x00cdee14     01570 
    0x00cdeea0 A T 01580 IF R <> H THEN 1660
    0x00cdef5c A   01590 IF S <> V THEN 1630
    0x00cdf03c A   01600 LET R = 1
    0x00cdf100 A   01610 LET S = 1
    0x00cdf13c A   01620 GOTO 1740
    0x00cdf200 A T 01630 LET R = 1
    0x00cdf308 A   01640 LET S = S+1
    0x00cdf54c A   01650 GOTO 1740
    0x00cdf648 A T 01660 LET R = R+1
    0x00cdf67c A   01670 
    0x00cdf6e8 A   01680 
    0x00cdf750 A   01690 REM                           STEPS 6500 THRU 13800 CHECK TO SEE
    0x00cdf808 A   01700 REM                           WHICH ADJACENT SQUARES ARE OPEN FOR
    0x00cdf8a0 A   01710 REM                           THE PATH TO FOLLOW.
    0x00cdf8dc A   01720 
    0x00cdf920 A   01730 
    0x00cdfa34 A T 01740 IF W(R,S) = 0 THEN 1580
    0x00cdfba4 A T 01750 IF R-1 = 0 THEN 2180
    0x00cdfd68 A   01760 IF W(R-1,S) <> 0 THEN 2180
    0x00cdfed8 A   01770 IF S-1 = 0 THEN 1950
    0x00cddc78 A   01780 IF W(R,S-1) <> 0 THEN 1950
    0x00ce0054 A   01790 IF R = H THEN 1840
    0x00ce0218 A   01800 IF W(R+1,S) <> 0 THEN 1840
    0x00ce040c A   01810 LET X = INT(RND*3+1)
    0x00ce0464 A   01820 REM                          LEFT,UP,RIGHT
    0x00ce0614 A   01830 ON X GOTO 2700,2770,2840
    0x00ce06ac A T 01840 IF S <> V THEN 1880
    0x00ce079c A   01850 IF Z = 1 THEN 1920
    0x00ce087c A   01860 LET Q = 1
    0x00ce08c8 A   01870 GOTO 1890
    0x00ce0a5c A T 01880 IF W(R,S+1) <> 0 THEN 1920
    0x00ce0c50 A T 01890 LET X = INT(RND*3+1)
    0x00ce0ca8 A   01900 REM                          LEFT,UP,DOWN
    0x00ce0e58 A   01910 ON X GOTO 2700,2770,2940
    0x00ce1024 A T 01920 LET X = INT(RND*2+1)
    0x00ce1078 A   01930 REM                          LEFT,UP
    0x00ce11c0 A   01940 ON X GOTO 2700,2770
    0x00ce1258 A T 01950 IF R = H THEN 2080
    0x00ce141c A   01960 IF W(R+1,S) <> 0 THEN 2080
    0x00ce14d4 A   01970 IF S<> V THEN 2010
    0x00ce15c4 A   01980 IF Z = 1 THEN 2050
    0x00ce16a4 A   01990 LET Q = 1
    0x00ce16f0 A   02000 GOTO 2020
    0x00ce1884 A T 02010 IF W(R,S+1) <> 0 THEN 2050
    0x00ce1a7c A T 02020 LET X = INT(RND*3+1)
    0x00ce1ad8 A   02030 REM                           LEFT,RIGHT,DOWN
    0x00ce1c88 A   02040 ON X GOTO 2700,2840,2940
    0x00ce1e58 A T 02050 LET X = INT(RND*2+1)
    0x00ce1eac A   02060 REM                          LEFT,RIGHT
    0x00ce1ff8 A   02070 ON X GOTO 2700,2840
    0x00ce2090 A T 02080 IF S <> V THEN 2120
    0x00ce2180 A   02090 IF Z = 1 THEN 2170
    0x00ce2260 A   02100 LET Q = 1
    0x00ce22ac A   02110 GOTO 2130
    0x00ce2440 A T 02120 IF W(R,S+1) <> 0 THEN 2170
    0x00ce2630 A T 02130 LET X = INT(RND*2+1)
    0x00ce2684 A   02140 REM                          LEFT,DOWN
    0x00ce27dc A   02150 ON X GOTO 2700,2940
    0x00ce2830 A   02160 REM                          LEFT
    0x00ce2888 A T 02170 GOTO 2700
    0x00ce29cc A T 02180 IF S-1 = 0 THEN 2430
    0x00ce2b90 A   02190 IF W(R,S-1) <> 0 THEN 2430
    0x00ce2c48 A   02200 IF R=H THEN 2330
    0x00ce2e0c A   02210 IF W(R+1,S) <> 0 THEN 2330
    0x00ce2ec4 A   02220 IF S<> V THEN 2260
    0x00ce2fb4 A   02230 IF Z = 1 THEN 2300
    0x00ce3094 A   02240 LET Q = 1
    0x00ce30e0 A   02250 GOTO 2270
    0x00ce3274 A T 02260 IF W(R,S+1) <> 0 THEN 2300
    0x00ce3468 A T 02270 LET X = INT(RND*3+1)
    0x00ce34c0 A   02280 REM                         UP,RIGHT,DOWN
    0x00ce3a74 A   02290 ON X GOTO 2770,2840,2940
    0x00ce3c40 A T 02300 LET X = INT(RND*2+1)
    0x00ce3c94 A   02310 REM                         UP,RIGHT
    0x00ce3de0 A   02320 ON X GOTO 2770,2840
    0x00ce3e78 A T 02330 IF S <> V THEN 2370
    0x00ce3f68 A   02340 IF Z = 1 THEN 2420
    0x00cdf388 A   02350 LET Q = 1
    0x00cdf3d4 A   02360 GOTO 2380
    0x00ce4038 A T 02370 IF W(R,S+1) <> 0 THEN 2420
    0x00ce4228 A T 02380 LET X = INT(RND*2+1)
    0x00ce4278 A   02390 REM                         UP,DOWN
    0x00ce43cc A   02400 ON X GOTO 2770,2940
    0x00ce441c A   02410 REM                         UP
    0x00ce4470 A T 02420 GOTO 2770
    0x00ce4500 A T 02430 IF R = H THEN 2550
    0x00ce46c4 A   02440 IF W(R+1,S) <> 0 THEN 2550
    0x00ce4780 A   02450 IF S <> V THEN 2490
    0x00ce4870 A   02460 IF Z = 1 THEN 2540
    0x00ce4950 A   02470 LET Q = 1
    0x00ce499c A   02480 GOTO 2500
    0x00ce4b30 A T 02490 IF W(R,S+1) <> 0 THEN 2540
    0x00ce4d20 A T 02500 LET X = INT(RND*2+1)
    0x00ce4d74 A   02510 REM                         RIGHT,DOWN
    0x00ce4ecc A   02520 ON X GOTO 2840,2940
    0x00ce4f20 A   02530 REM                         RIGHT
    0x00ce4f78 A T 02540 GOTO 2840
    0x00ce5008 A T 02550 IF S <> V THEN 2590
    0x00ce50f8 A   02560 IF Z = 1 THEN 2630
    0x00ce51d8 A   02570 LET Q = 1
    0x00ce5224 A   02580 GOTO 2610
    0x00ce53b8 A T 02590 IF W(R,S+1) <> 0 THEN 2630
    0x00ce543c A   02600 REM                         DOWN
    0x00ce54a4 A T 02610 GOTO 2940
    0x00ce54f0 A   02620 REM                         BLOCKED
    0x00ce5534 A T 02630 GOTO 3140
    0x00ce5564     02640 
    0x00ce55d0     02650 
    0x00ce5638 A   02660 REM                          STEPS 13900 THRU 18100 MAKE A RANDOM
    0x00ce56dc A   02670 REM                          CHOICE OF AVAILABLE PATHS.
    0x00ce5718     02680 
    0x00ce5754     02690 
    0x00ce58a8 A T 02700 LET W(R-1,S) = C
    0x00ce59b8 A   02710 LET C = C+1
    0x00ce5b4c A   02720 LET V(R-1,S) = 2
    0x00ce5c60 A   02730 LET R = R-1
    0x00ce5db4 A   02740 IF C = H*V+1 THEN 3160
    0x00ce5e94 A   02750 LET Q = 0
    0x00ce5ed8 A   02760 GOTO 1750
    0x00ce6030 A T 02770 LET W(R,S-1) = C
    0x00ce6140 A   02780 LET C = C+1
    0x00ce62d4 A   02790 LET V(R,S-1) = 1
    0x00ce63e8 A   02800 LET S = S-1
    0x00ce653c A   02810 IF C = H*V+1 THEN 3160
    0x00ce661c A   02820 LET Q = 0
    0x00ce6660 A   02830 GOTO 1750
    0x00ce67b8 A T 02840 LET W(R+1,S) = C
    0x00ce68d0 A   02850 LET C = C+1
    0x00ce69ec A   02860 IF V(R,S) = 0 THEN 2890
    0x00ce6b20 A   02870 LET V(R,S) = 3
    0x00ce6b60 A   02880 GOTO 2900
    0x00ce6c74 A T 02890 LET V(R,S) = 2
    0x00ce6d88 A T 02900 LET R = R+1
    0x00ce6edc A   02910 IF C = H*V+1 THEN 3160
    0x00ce6fbc A   02920 LET Q = 0
    0x00ce7000 A   02930 GOTO 2180
    0x00ce70c8 A T 02940 IF Q = 1 THEN 3040
    0x00ce7248 A   02950 LET W (R,S+1) = C
    0x00ce7360 A   02960 LET C = C+1
    0x00ce747c A   02970 IF V(R,S) = 0 THEN 3000
    0x00ce75b0 A   02980 LET V(R,S) = 3
    0x00ce75f0 A   02990 GOTO 3010
    0x00ce7704 A T 03000 LET V(R,S) = 1
    0x00ce7818 A T 03010 LET S = S+1
    0x00ce796c A   03020 IF C = H*V+1 THEN 3160
    0x00ce79c4 A   03030 GOTO 1750
    0x00ce7a94 A T 03040 LET Z = 1
    0x00ce7bb0 A   03050 IF V(R,S) = 0 THEN 3090
    0x00ce7ce4 A   03060 LET V(R,S) = 3
    0x00ce7da8 A   03070 LET Q = 0
    0x00ce7de8 A   03080 GOTO 3140
    0x00ce7ef8 A T 03090 LET V(R,S) = 1
    0x00ce7fbc A   03100 LET Q = 0
    0x00ce8080 A   03110 LET R = 1
    0x00ce8144 A   03120 LET S = 1
    0x00ce8180 A   03130 GOTO 1740
    0x00ce81ec A T 03140 GOTO 1580
    0x00ce8254 A   03150 REM                         PRINTS OUT THE MAZE FROM HERE ON.
    0x00ce839c A T 03160 FOR J = 1 TO V
    0x00ce8468 A   03170  PRINT "I";
    0x00ce8568 A   03180  FOR I = 1 TO H
    0x00ce868c A   03190  IF V(I,J) < 2 THEN 3220
    0x00ce876c A   03200   PRINT "   ";
    0x00ce87b0 A   03210   GOTO 3230
    0x00ce8868 A T 03220   PRINT "  I";
    0x00ce88bc A T 03230  NEXT I
    0x00ce88fc A   03240  PRINT
    0x00ce89fc A   03250  FOR I = 1 TO H
    0x00ce8b20 A   03260   IF V(I,J) = 0 THEN 3300
    0x00ce8c68 A   03270   IF V(I,J) = 2 THEN 3300
    0x00ce8d48 A   03280   PRINT ":  ";
    0x00ce8d8c A   03290   GOTO 3310
    0x00ce8e44 A T 03300   PRINT ":--";
    0x00ce8e98 A T 03310  NEXT I
    0x00ce8f4c A   03320 PRINT ":"
    0x00ce8fa0 A   03330 NEXT J
    0x00ce8fd4 A   03340 END
 */

/*
 * Line reference table:
 *

    Target
   Line Num.    Referencing line number (Reference is T-GOTO or G-GOSUB).
   ---------    -------------------------------------------------------------------
     01160      01230T
     01240      01190T, 01200T
     01390      01360T
     01400      01380T
     01580      01740T, 03140T
     01630      01590T
     01660      01580T
     01740      01620T, 01650T, 03130T
     01750      01470T, 02760T, 02830T, 03030T
     01840      01790T, 01800T
     01880      01840T
     01890      01870T
     01920      01850T, 01880T
     01950      01770T, 01780T
     02010      01970T
     02020      02000T
     02050      01980T, 02010T
     02080      01950T, 01960T
     02120      02080T
     02130      02110T
     02170      02090T, 02120T
     02180      01750T, 01760T, 02930T
     02260      02220T
     02270      02250T
     02300      02230T, 02260T
     02330      02200T, 02210T
     02370      02330T
     02380      02360T
     02420      02340T, 02370T
     02430      02180T, 02190T
     02490      02450T
     02500      02480T
     02540      02460T, 02490T
     02550      02430T, 02440T
     02590      02550T
     02610      02580T
     02630      02560T, 02590T
     02700      01830T, 01910T, 01940T, 02040T, 02070T, 02150T, 02170T
     02770      01830T, 01910T, 01940T, 02290T, 02320T, 02400T, 02420T
     02840      01830T, 02040T, 02070T, 02290T, 02320T, 02520T, 02540T
     02890      02860T
     02900      02880T
     02940      01910T, 02040T, 02150T, 02290T, 02400T, 02520T, 02610T
     03000      02970T
     03010      02990T
     03040      02940T
     03090      03050T
     03140      02630T, 03080T
     03160      02740T, 02810T, 02910T, 03020T
     03220      03190T
     03230      03210T
     03300      03260T, 03270T
     03310      03290T

 */

/* 
 * Routine Start, Target, Return and End Program Addresses 
 * 

  Rtn    Start       Target       Return         End    
  --- ----------   ----------   ----------   ---------- 
   A) 0x00ce3508   0x00ce3508   0x00ce38b0   0x00ce38b0 


 */


/* 
 * Routine Start, Target, Return and End Program Addresses 
 * 

  Rtn    Start       Target       Return         End    
  --- ----------   ----------   ----------   ---------- 
   A) 0x00ce3508   0x00ce3508   0x00ce38b0   0x00ce38b0 


 */



/*
 * Free line number map.
 *
     Start    End    # Lines in Gap
     -----   -----   ------------------
     00000 - 00990     100 
     03350 - 10000    6660 

 */



/*
 *  Symbol Table Listing for '..\basic\Maze.bas'
 *
    C              Integer 
    H              Integer 
    I              Integer 
    INT   Function Integer     args=1, float 
    J              Integer 
    Q              Integer 
    R              Integer 
    RND   Function Integer     args=1, int   
    S              Integer 
    V     Array    Integer     {0,26} {0,104} 
    V              Integer 
    W     Array    Integer     {0,26} {0,104} 
    X              Integer 
    Z              Integer 

 */


/*
 * Title: Display of final 'clean' BASIC listing.
 *
 *  Listing of D:\Dev\BasicGames\Translator\basic\Maze.bas: 
 *
               +---- Routine IDs (Empty field=Inaccessible code, A=Main program).
               | +-- Target status (G-GOSUB, T-GOTO, B-Both GOSUB and GOTO)
      Program  | |
      Address  v v Original BASIC statement
    ---------- - - ------------------------------------------------------------------------------
    0x00cdbaf8 A   01000 PRINT"D A T A L I N E   S Y S T E M S   L T D."
    0x00cdbbc0 A   01010 PRINT"BASIC LIBRARY--'AMAZES'--19-JUL-70"
    0x00cdbbf8 A   01020 REM
    0x00cdbca0 A   01030 REM  DESCRIPTION--CONSTRUCTS A DIFFERENT MAZE EVERY TIME
    0x00cdbd50 A   01040 REM  IT IS RUN WITH ONLY ONE SOLUTION. THE USER CHOOSES THE 
    0x00cdbdbc A   01050 REM  DIMENSION OF THE MAZE.
    0x00cdbe7c A   01060 REM  *  *  *  *  *  *   MAIN PROGRAM   *  *  *  *  *  *  *  *  *  *  *
    0x00cdbebc A   01070 REM 
    0x00cdbf18 A   01080 RANDOMIZE
    0x00cdcc60 A   01090 DIM W(25,103), V(25,103)
    0x00cdcd78 A   01100 PRINT "THIS PROGRAM WILL PRINT OUT A DIFFERENT MAZE EVERY TIME IT"
    0x00cdce98 A   01110 PRINT "IS RUN AND GUARANTEES ONLY ONE PATH THROUGH.  YOU CAN CHOOSE"
    0x00cdcfb4 A   01120 PRINT "THE DIMENSIONS OF THE MAZE. I.E. THE NUMBER OF SQUARES WIDE"
    0x00cdd0c8 A   01130 PRINT "AND THE NUMBER OF SQUARES LONG.  A 23 BY 25 MAZE IS THE "
    0x00cdd1a4 A   01140 PRINT "MAXIMUM, BUT ANY DIMENSIONS UP TO THESE LIMITS ARE OK."
    0x00cdd204 A   01150 PRINT
    0x00cdd2e0 A T 01160 PRINT "WHAT ARE YOUR WIDTH AND LENGTH";
    0x00cdd3f4 A   01170 INPUT H,V
    0x00cdd43c A   01180 PRINT
    0x00cd1948 A   01190 IF H<>1 THEN 1240
    0x00cdd5cc A   01200 IF V<>1 THEN 1240
    0x00cdd6cc A   01210 PRINT "MEANINGLESS DIMENSIONS, TRY AGAIN."
    0x00cdd70c A   01220 PRINT
    0x00cdd748 A   01230 GO TO 1160
    0x00cdd77c A T 01240 PRINT
    0x00cdd7bc A   01250 PRINT
    0x00cdd8c8 A   01260 LET Q = 0
    0x00cdd9c8 A   01270 LET Z = 0
    0x00cdd9fc A   01280 
    0x00cdda64 A   01290 
    0x00cddac4 A   01300 REM                           STEPS 1900 THRU 3200 PICK THE
    0x00cddb68 A   01310 REM                           SQUARE IN WHICH TO START.
    0x00cddba4 A   01320 
    0x00cddce8 A   01330 
    0x00cddf24 A   01340 LET X = INT(RND*H+1)
    0x00cde060 A   01350 FOR I = 1 TO H
    0x00cde0fc A   01360  IF I = X THEN 1390
    0x00cde1d8 A   01370  PRINT ":--";
    0x00cde21c A   01380  GOTO 1400
    0x00cde2d0 A T 01390  PRINT ":  ";
    0x00cde324 A T 01400 NEXT I
    0x00cde3dc A   01410 PRINT ":"
    0x00cde4ec A   01420 LET C = 1
    0x00cde604 A   01430 LET W(X,1) = C
    0x00cde70c A   01440 LET C = C+1
    0x00cde7dc A   01450 LET R = X
    0x00cde8e4 A   01460 LET S = 1
    0x00cde918 A   01470 GOTO 1750
    0x00cde948     01480 
    0x00cde9b4     01490 
    0x00cdea18 A   01500 REM                           STEPS 4900 THRU 5700 LOOK FOR THE
    0x00cdeac8 A   01510 REM                           SQUARE IN WHICH TO START A NEW 
    0x00cdeb80 A   01520 REM                           PATH WHEN THE OLD ONE GETS BLOCKED.
    0x00cdec38 A   01530 REM                           THE LINES ARE SCANNED FOR A SQUARE
    0x00cdecf0 A   01540 REM                           WHICH HAS ALREADY BEEN USED BUT IS
    0x00cded98 A   01550 REM                           ADJACENT TO AN OPEN SQUARE.
    0x00cdedd4     01560 
    0x00cdee14     01570 
    0x00cdeea0 A T 01580 IF R <> H THEN 1660
    0x00cdef5c A   01590 IF S <> V THEN 1630
    0x00cdf03c A   01600 LET R = 1
    0x00cdf100 A   01610 LET S = 1
    0x00cdf13c A   01620 GOTO 1740
    0x00cdf200 A T 01630 LET R = 1
    0x00cdf308 A   01640 LET S = S+1
    0x00cdf54c A   01650 GOTO 1740
    0x00cdf648 A T 01660 LET R = R+1
    0x00cdf67c A   01670 
    0x00cdf6e8 A   01680 
    0x00cdf750 A   01690 REM                           STEPS 6500 THRU 13800 CHECK TO SEE
    0x00cdf808 A   01700 REM                           WHICH ADJACENT SQUARES ARE OPEN FOR
    0x00cdf8a0 A   01710 REM                           THE PATH TO FOLLOW.
    0x00cdf8dc A   01720 
    0x00cdf920 A   01730 
    0x00cdfa34 A T 01740 IF W(R,S) = 0 THEN 1580
    0x00cdfba4 A T 01750 IF R-1 = 0 THEN 2180
    0x00cdfd68 A   01760 IF W(R-1,S) <> 0 THEN 2180
    0x00cdfed8 A   01770 IF S-1 = 0 THEN 1950
    0x00cddc78 A   01780 IF W(R,S-1) <> 0 THEN 1950
    0x00ce0054 A   01790 IF R = H THEN 1840
    0x00ce0218 A   01800 IF W(R+1,S) <> 0 THEN 1840
    0x00ce040c A   01810 LET X = INT(RND*3+1)
    0x00ce0464 A   01820 REM                          LEFT,UP,RIGHT
    0x00ce0614 A   01830 ON X GOTO 2700,2770,2840
    0x00ce06ac A T 01840 IF S <> V THEN 1880
    0x00ce079c A   01850 IF Z = 1 THEN 1920
    0x00ce087c A   01860 LET Q = 1
    0x00ce08c8 A   01870 GOTO 1890
    0x00ce0a5c A T 01880 IF W(R,S+1) <> 0 THEN 1920
    0x00ce0c50 A T 01890 LET X = INT(RND*3+1)
    0x00ce0ca8 A   01900 REM                          LEFT,UP,DOWN
    0x00ce0e58 A   01910 ON X GOTO 2700,2770,2940
    0x00ce1024 A T 01920 LET X = INT(RND*2+1)
    0x00ce1078 A   01930 REM                          LEFT,UP
    0x00ce11c0 A   01940 ON X GOTO 2700,2770
    0x00ce1258 A T 01950 IF R = H THEN 2080
    0x00ce141c A   01960 IF W(R+1,S) <> 0 THEN 2080
    0x00ce14d4 A   01970 IF S<> V THEN 2010
    0x00ce15c4 A   01980 IF Z = 1 THEN 2050
    0x00ce16a4 A   01990 LET Q = 1
    0x00ce16f0 A   02000 GOTO 2020
    0x00ce1884 A T 02010 IF W(R,S+1) <> 0 THEN 2050
    0x00ce1a7c A T 02020 LET X = INT(RND*3+1)
    0x00ce1ad8 A   02030 REM                           LEFT,RIGHT,DOWN
    0x00ce1c88 A   02040 ON X GOTO 2700,2840,2940
    0x00ce1e58 A T 02050 LET X = INT(RND*2+1)
    0x00ce1eac A   02060 REM                          LEFT,RIGHT
    0x00ce1ff8 A   02070 ON X GOTO 2700,2840
    0x00ce2090 A T 02080 IF S <> V THEN 2120
    0x00ce2180 A   02090 IF Z = 1 THEN 2170
    0x00ce2260 A   02100 LET Q = 1
    0x00ce22ac A   02110 GOTO 2130
    0x00ce2440 A T 02120 IF W(R,S+1) <> 0 THEN 2170
    0x00ce2630 A T 02130 LET X = INT(RND*2+1)
    0x00ce2684 A   02140 REM                          LEFT,DOWN
    0x00ce27dc A   02150 ON X GOTO 2700,2940
    0x00ce2830 A   02160 REM                          LEFT
    0x00ce2888 A T 02170 GOTO 2700
    0x00ce29cc A T 02180 IF S-1 = 0 THEN 2430
    0x00ce2b90 A   02190 IF W(R,S-1) <> 0 THEN 2430
    0x00ce2c48 A   02200 IF R=H THEN 2330
    0x00ce2e0c A   02210 IF W(R+1,S) <> 0 THEN 2330
    0x00ce2ec4 A   02220 IF S<> V THEN 2260
    0x00ce2fb4 A   02230 IF Z = 1 THEN 2300
    0x00ce3094 A   02240 LET Q = 1
    0x00ce30e0 A   02250 GOTO 2270
    0x00ce3274 A T 02260 IF W(R,S+1) <> 0 THEN 2300
    0x00ce3468 A T 02270 LET X = INT(RND*3+1)
    0x00ce34c0 A   02280 REM                         UP,RIGHT,DOWN
    0x00ce3a74 A   02290 ON X GOTO 2770,2840,2940
    0x00ce3c40 A T 02300 LET X = INT(RND*2+1)
    0x00ce3c94 A   02310 REM                         UP,RIGHT
    0x00ce3de0 A   02320 ON X GOTO 2770,2840
    0x00ce3e78 A T 02330 IF S <> V THEN 2370
    0x00ce3f68 A   02340 IF Z = 1 THEN 2420
    0x00cdf388 A   02350 LET Q = 1
    0x00cdf3d4 A   02360 GOTO 2380
    0x00ce4038 A T 02370 IF W(R,S+1) <> 0 THEN 2420
    0x00ce4228 A T 02380 LET X = INT(RND*2+1)
    0x00ce4278 A   02390 REM                         UP,DOWN
    0x00ce43cc A   02400 ON X GOTO 2770,2940
    0x00ce441c A   02410 REM                         UP
    0x00ce4470 A T 02420 GOTO 2770
    0x00ce4500 A T 02430 IF R = H THEN 2550
    0x00ce46c4 A   02440 IF W(R+1,S) <> 0 THEN 2550
    0x00ce4780 A   02450 IF S <> V THEN 2490
    0x00ce4870 A   02460 IF Z = 1 THEN 2540
    0x00ce4950 A   02470 LET Q = 1
    0x00ce499c A   02480 GOTO 2500
    0x00ce4b30 A T 02490 IF W(R,S+1) <> 0 THEN 2540
    0x00ce4d20 A T 02500 LET X = INT(RND*2+1)
    0x00ce4d74 A   02510 REM                         RIGHT,DOWN
    0x00ce4ecc A   02520 ON X GOTO 2840,2940
    0x00ce4f20 A   02530 REM                         RIGHT
    0x00ce4f78 A T 02540 GOTO 2840
    0x00ce5008 A T 02550 IF S <> V THEN 2590
    0x00ce50f8 A   02560 IF Z = 1 THEN 2630
    0x00ce51d8 A   02570 LET Q = 1
    0x00ce5224 A   02580 GOTO 2610
    0x00ce53b8 A T 02590 IF W(R,S+1) <> 0 THEN 2630
    0x00ce543c A   02600 REM                         DOWN
    0x00ce54a4 A T 02610 GOTO 2940
    0x00ce54f0 A   02620 REM                         BLOCKED
    0x00ce5534 A T 02630 GOTO 3140
    0x00ce5564     02640 
    0x00ce55d0     02650 
    0x00ce5638 A   02660 REM                          STEPS 13900 THRU 18100 MAKE A RANDOM
    0x00ce56dc A   02670 REM                          CHOICE OF AVAILABLE PATHS.
    0x00ce5718     02680 
    0x00ce5754     02690 
    0x00ce58a8 A T 02700 LET W(R-1,S) = C
    0x00ce59b8 A   02710 LET C = C+1
    0x00ce5b4c A   02720 LET V(R-1,S) = 2
    0x00ce5c60 A   02730 LET R = R-1
    0x00ce5db4 A   02740 IF C = H*V+1 THEN 3160
    0x00ce5e94 A   02750 LET Q = 0
    0x00ce5ed8 A   02760 GOTO 1750
    0x00ce6030 A T 02770 LET W(R,S-1) = C
    0x00ce6140 A   02780 LET C = C+1
    0x00ce62d4 A   02790 LET V(R,S-1) = 1
    0x00ce63e8 A   02800 LET S = S-1
    0x00ce653c A   02810 IF C = H*V+1 THEN 3160
    0x00ce661c A   02820 LET Q = 0
    0x00ce6660 A   02830 GOTO 1750
    0x00ce67b8 A T 02840 LET W(R+1,S) = C
    0x00ce68d0 A   02850 LET C = C+1
    0x00ce69ec A   02860 IF V(R,S) = 0 THEN 2890
    0x00ce6b20 A   02870 LET V(R,S) = 3
    0x00ce6b60 A   02880 GOTO 2900
    0x00ce6c74 A T 02890 LET V(R,S) = 2
    0x00ce6d88 A T 02900 LET R = R+1
    0x00ce6edc A   02910 IF C = H*V+1 THEN 3160
    0x00ce6fbc A   02920 LET Q = 0
    0x00ce7000 A   02930 GOTO 2180
    0x00ce70c8 A T 02940 IF Q = 1 THEN 3040
    0x00ce7248 A   02950 LET W (R,S+1) = C
    0x00ce7360 A   02960 LET C = C+1
    0x00ce747c A   02970 IF V(R,S) = 0 THEN 3000
    0x00ce75b0 A   02980 LET V(R,S) = 3
    0x00ce75f0 A   02990 GOTO 3010
    0x00ce7704 A T 03000 LET V(R,S) = 1
    0x00ce7818 A T 03010 LET S = S+1
    0x00ce796c A   03020 IF C = H*V+1 THEN 3160
    0x00ce79c4 A   03030 GOTO 1750
    0x00ce7a94 A T 03040 LET Z = 1
    0x00ce7bb0 A   03050 IF V(R,S) = 0 THEN 3090
    0x00ce7ce4 A   03060 LET V(R,S) = 3
    0x00ce7da8 A   03070 LET Q = 0
    0x00ce7de8 A   03080 GOTO 3140
    0x00ce7ef8 A T 03090 LET V(R,S) = 1
    0x00ce7fbc A   03100 LET Q = 0
    0x00ce8080 A   03110 LET R = 1
    0x00ce8144 A   03120 LET S = 1
    0x00ce8180 A   03130 GOTO 1740
    0x00ce81ec A T 03140 GOTO 1580
    0x00ce8254 A   03150 REM                         PRINTS OUT THE MAZE FROM HERE ON.
    0x00ce839c A T 03160 FOR J = 1 TO V
    0x00ce8468 A   03170  PRINT "I";
    0x00ce8568 A   03180  FOR I = 1 TO H
    0x00ce868c A   03190  IF V(I,J) < 2 THEN 3220
    0x00ce876c A   03200   PRINT "   ";
    0x00ce87b0 A   03210   GOTO 3230
    0x00ce8868 A T 03220   PRINT "  I";
    0x00ce88bc A T 03230  NEXT I
    0x00ce88fc A   03240  PRINT
    0x00ce89fc A   03250  FOR I = 1 TO H
    0x00ce8b20 A   03260   IF V(I,J) = 0 THEN 3300
    0x00ce8c68 A   03270   IF V(I,J) = 2 THEN 3300
    0x00ce8d48 A   03280   PRINT ":  ";
    0x00ce8d8c A   03290   GOTO 3310
    0x00ce8e44 A T 03300   PRINT ":--";
    0x00ce8e98 A T 03310  NEXT I
    0x00ce8f4c A   03320 PRINT ":"
    0x00ce8fa0 A   03330 NEXT J
    0x00ce8fd4 A   03340 END
 */

//---------------------------------------------------------------------------
// $Header: D:\\Repository\\D\\Dev\\BasicGames\\Translator\\Translated\\Maze.cpp,v 1.6 2011-10-16 22:43:31-04 alan Exp alan $ 
//
// NOTE: This program has been automatically tranlated by b2cpp
//
// $Log: Maze.cpp,v $
// Revision 1.6  2011-10-16 22:43:31-04  alan
// Updating the translation of the BASIC programs.
// 
// 
//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//---------------------------------------------------------------------------
// Global data area.
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------




typedef enum {TYPE_None,TYPE_Integer,TYPE_Float,TYPE_String}t_type;
typedef struct{
    int    LineNum;
    int    Size;
    char** SData;
}t_data;
t_data ProgramData[] = {
    {    0,  0,NULL       }
};

#include "intrinsics.h"


//---------------------------------------------------------------------------
// Global variable area.
//
// NOTE: Variable names are long to allow for easy editing.
//---------------------------------------------------------------------------
int   C_int;        // Comments?
int   H_int;        // Comments?
int   I_int;        // Comments?
int   J_int;        // Comments?
int   Q_int;        // Comments?
int   R_int;        // Comments?
int   S_int;        // Comments?
int   V_int_arr[26][104];   // Comments?
int   V_int;        // Comments?
int   W_int_arr[26][104];   // Comments?
int   X_int;        // Comments?
int   Z_int;        // Comments?
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
char* GLBpStr=NULL;
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Subroutine Prototypes.
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Program Functions.
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// Program Subroutines.
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Main Program.
//---------------------------------------------------------------------------
#pragma argsused
void main(int argc,char *argv[])
{
    // 01000 PRINT"D A T A L I N E   S Y S T E M S   L T D."
    MyFpf(stdout,"d a t a l i n e   s y s t e m s   l t d.\n");
    // 01010 PRINT"BASIC LIBRARY--'AMAZES'--19-JUL-70"
    MyFpf(stdout,"basic library--'amazes'--19-jul-70\n");
    // 01020 REM
    //
    // 01030 REM  DESCRIPTION--CONSTRUCTS A DIFFERENT MAZE EVERY TIME
    //  description--constructs a different maze every time
    // 01040 REM  IT IS RUN WITH ONLY ONE SOLUTION. THE USER CHOOSES THE 
    //  it is run with only one solution. the user chooses the 
    // 01050 REM  DIMENSION OF THE MAZE.
    //  dimension of the maze.
    // 01060 REM  *  *  *  *  *  *   MAIN PROGRAM   *  *  *  *  *  *  *  *  *  *  *
    //  *  *  *  *  *  *   main program   *  *  *  *  *  *  *  *  *  *  *
    // 01070 REM 
    // 
    // 01080 RANDOMIZE
    char ranbuf_01080[10]; 
    printf("Random number seed (-32768 to 32767)? "); 
    if(fgets(ranbuf_01080,9,stdin)!=NULL){ 
        int seed=atoi(ranbuf_01080); 
        srand(seed); 
    } 
    // 01090 DIM W(25,103), V(25,103)
    // 01100 PRINT "THIS PROGRAM WILL PRINT OUT A DIFFERENT MAZE EVERY TIME IT"
    MyFpf(stdout,"this program will print out a different maze every time it\n");
    // 01110 PRINT "IS RUN AND GUARANTEES ONLY ONE PATH THROUGH.  YOU CAN CHOOSE"
    MyFpf(stdout,"is run and guarantees only one path through.  you can choose\n");
    // 01120 PRINT "THE DIMENSIONS OF THE MAZE. I.E. THE NUMBER OF SQUARES WIDE"
    MyFpf(stdout,"the dimensions of the maze. i.e. the number of squares wide\n");
    // 01130 PRINT "AND THE NUMBER OF SQUARES LONG.  A 23 BY 25 MAZE IS THE "
    MyFpf(stdout,"and the number of squares long.  a 23 by 25 maze is the \n");
    // 01140 PRINT "MAXIMUM, BUT ANY DIMENSIONS UP TO THESE LIMITS ARE OK."
    MyFpf(stdout,"maximum, but any dimensions up to these limits are ok.\n");
    // 01150 PRINT
    MyFpf(stdout,"\n");

  Lbl_01160:
    // 01160 PRINT "WHAT ARE YOUR WIDTH AND LENGTH";
    MyFpf(stdout,"what are your width and length");
    // 01170 INPUT H,V
    // Start of Basic INPUT statement 01170
    printf(" ? ");
    char inpbuf_01170[100];
    if(fgets(inpbuf_01170,100,stdin)==NULL){
        fprintf(stderr,"ERROR: End of file on input.\n");
        exit(2);
    }else{
        // This may cause problems if BASIC programmer expected
        // input strings to be copied instead of just pointing
        // to the input buffer (ie. strings can be over written).
        char *ps_01170=strtok(inpbuf_01170," ,\t\n");
        if(ps_01170==NULL){
            H_int = 0;
        }else{
            H_int = atoi(ps_01170);
        };
        ps_01170=strtok(NULL," ,\t\n");
        if(ps_01170==NULL){
            V_int = 0;
        }else{
            V_int = atoi(ps_01170);
        };
    }; // End of Basic INPUT statement 01170
    // 01180 PRINT
    MyFpf(stdout,"\n");
    // 01190 IF H<>1 THEN 1240
    if(H_int!=1) goto Lbl_01240;
    // 01200 IF V<>1 THEN 1240
    if(V_int!=1) goto Lbl_01240;
    // 01210 PRINT "MEANINGLESS DIMENSIONS, TRY AGAIN."
    MyFpf(stdout,"meaningless dimensions, try again.\n");
    // 01220 PRINT
    MyFpf(stdout,"\n");
    // 01230 GO TO 1160
    goto Lbl_01160;

  Lbl_01240:
    // 01240 PRINT
    MyFpf(stdout,"\n");
    // 01250 PRINT
    MyFpf(stdout,"\n");
    // 01260 LET Q = 0
    Q_int = 0;
    // 01270 LET Z = 0
    Z_int = 0;
    // 01280 
    
    // 01290 
    
    // 01300 REM                           STEPS 1900 THRU 3200 PICK THE
    //                           steps 1900 thru 3200 pick the
    // 01310 REM                           SQUARE IN WHICH TO START.
    //                           square in which to start.
    // 01320 
    
    // 01330 
    
    // 01340 LET X = INT(RND*H+1)
    X_int = INT(RND()*H_int+1);
    // 01350 FOR I = 1 TO H
    for(I_int=1;I_int<=H_int;I_int++){
        // 01360  IF I = X THEN 1390
        if(I_int==X_int) goto Lbl_01390;
        // 01370  PRINT ":--";
        MyFpf(stdout,":--");
        // 01380  GOTO 1400
        goto Lbl_01400;

  Lbl_01390:
        // 01390  PRINT ":  ";
        MyFpf(stdout,":  ");

  Lbl_01400:
        // 01400 NEXT I
    }; // End-For(I_int)
    // 01410 PRINT ":"
    MyFpf(stdout,":\n");
    // 01420 LET C = 1
    C_int = 1;
    // 01430 LET W(X,1) = C
    W_int_arr[(int)X_int][(int)1] = C_int;
    // 01440 LET C = C+1
    C_int = C_int+1;
    // 01450 LET R = X
    R_int = X_int;
    // 01460 LET S = 1
    S_int = 1;
    // 01470 GOTO 1750
    goto Lbl_01750;
    
    
    // 01500 REM                           STEPS 4900 THRU 5700 LOOK FOR THE
    //                           steps 4900 thru 5700 look for the
    // 01510 REM                           SQUARE IN WHICH TO START A NEW 
    //                           square in which to start a new 
    // 01520 REM                           PATH WHEN THE OLD ONE GETS BLOCKED.
    //                           path when the old one gets blocked.
    // 01530 REM                           THE LINES ARE SCANNED FOR A SQUARE
    //                           the lines are scanned for a square
    // 01540 REM                           WHICH HAS ALREADY BEEN USED BUT IS
    //                           which has already been used but is
    // 01550 REM                           ADJACENT TO AN OPEN SQUARE.
    //                           adjacent to an open square.
    
    

  Lbl_01580:
    // 01580 IF R <> H THEN 1660
    if(R_int!=H_int) goto Lbl_01660;
    // 01590 IF S <> V THEN 1630
    if(S_int!=V_int) goto Lbl_01630;
    // 01600 LET R = 1
    R_int = 1;
    // 01610 LET S = 1
    S_int = 1;
    // 01620 GOTO 1740
    goto Lbl_01740;

  Lbl_01630:
    // 01630 LET R = 1
    R_int = 1;
    // 01640 LET S = S+1
    S_int = S_int+1;
    // 01650 GOTO 1740
    goto Lbl_01740;

  Lbl_01660:
    // 01660 LET R = R+1
    R_int = R_int+1;
    // 01670 
    
    // 01680 
    
    // 01690 REM                           STEPS 6500 THRU 13800 CHECK TO SEE
    //                           steps 6500 thru 13800 check to see
    // 01700 REM                           WHICH ADJACENT SQUARES ARE OPEN FOR
    //                           which adjacent squares are open for
    // 01710 REM                           THE PATH TO FOLLOW.
    //                           the path to follow.
    // 01720 
    
    // 01730 
    

  Lbl_01740:
    // 01740 IF W(R,S) = 0 THEN 1580
    if(W_int_arr[(int)R_int][(int)S_int]==0) goto Lbl_01580;

  Lbl_01750:
    // 01750 IF R-1 = 0 THEN 2180
    if(R_int-1==0) goto Lbl_02180;
    // 01760 IF W(R-1,S) <> 0 THEN 2180
    if(W_int_arr[(int)R_int-1][(int)S_int]!=0) goto Lbl_02180;
    // 01770 IF S-1 = 0 THEN 1950
    if(S_int-1==0) goto Lbl_01950;
    // 01780 IF W(R,S-1) <> 0 THEN 1950
    if(W_int_arr[(int)R_int][(int)S_int-1]!=0) goto Lbl_01950;
    // 01790 IF R = H THEN 1840
    if(R_int==H_int) goto Lbl_01840;
    // 01800 IF W(R+1,S) <> 0 THEN 1840
    if(W_int_arr[(int)R_int+1][(int)S_int]!=0) goto Lbl_01840;
    // 01810 LET X = INT(RND*3+1)
    X_int = INT(RND()*3+1);
    // 01820 REM                          LEFT,UP,RIGHT
    //                          left,up,right
    // 01830 ON X GOTO 2700,2770,2840
    switch((int)(X_int)){
        case 1: goto Lbl_02700;
        case 2: goto Lbl_02770;
        case 3: goto Lbl_02840;
        default: break; 
    };

  Lbl_01840:
    // 01840 IF S <> V THEN 1880
    if(S_int!=V_int) goto Lbl_01880;
    // 01850 IF Z = 1 THEN 1920
    if(Z_int==1) goto Lbl_01920;
    // 01860 LET Q = 1
    Q_int = 1;
    // 01870 GOTO 1890
    goto Lbl_01890;

  Lbl_01880:
    // 01880 IF W(R,S+1) <> 0 THEN 1920
    if(W_int_arr[(int)R_int][(int)S_int+1]!=0) goto Lbl_01920;

  Lbl_01890:
    // 01890 LET X = INT(RND*3+1)
    X_int = INT(RND()*3+1);
    // 01900 REM                          LEFT,UP,DOWN
    //                          left,up,down
    // 01910 ON X GOTO 2700,2770,2940
    switch((int)(X_int)){
        case 1: goto Lbl_02700;
        case 2: goto Lbl_02770;
        case 3: goto Lbl_02940;
        default: break; 
    };

  Lbl_01920:
    // 01920 LET X = INT(RND*2+1)
    X_int = INT(RND()*2+1);
    // 01930 REM                          LEFT,UP
    //                          left,up
    // 01940 ON X GOTO 2700,2770
    switch((int)(X_int)){
        case 1: goto Lbl_02700;
        case 2: goto Lbl_02770;
        default: break; 
    };

  Lbl_01950:
    // 01950 IF R = H THEN 2080
    if(R_int==H_int) goto Lbl_02080;
    // 01960 IF W(R+1,S) <> 0 THEN 2080
    if(W_int_arr[(int)R_int+1][(int)S_int]!=0) goto Lbl_02080;
    // 01970 IF S<> V THEN 2010
    if(S_int!=V_int) goto Lbl_02010;
    // 01980 IF Z = 1 THEN 2050
    if(Z_int==1) goto Lbl_02050;
    // 01990 LET Q = 1
    Q_int = 1;
    // 02000 GOTO 2020
    goto Lbl_02020;

  Lbl_02010:
    // 02010 IF W(R,S+1) <> 0 THEN 2050
    if(W_int_arr[(int)R_int][(int)S_int+1]!=0) goto Lbl_02050;

  Lbl_02020:
    // 02020 LET X = INT(RND*3+1)
    X_int = INT(RND()*3+1);
    // 02030 REM                           LEFT,RIGHT,DOWN
    //                           left,right,down
    // 02040 ON X GOTO 2700,2840,2940
    switch((int)(X_int)){
        case 1: goto Lbl_02700;
        case 2: goto Lbl_02840;
        case 3: goto Lbl_02940;
        default: break; 
    };

  Lbl_02050:
    // 02050 LET X = INT(RND*2+1)
    X_int = INT(RND()*2+1);
    // 02060 REM                          LEFT,RIGHT
    //                          left,right
    // 02070 ON X GOTO 2700,2840
    switch((int)(X_int)){
        case 1: goto Lbl_02700;
        case 2: goto Lbl_02840;
        default: break; 
    };

  Lbl_02080:
    // 02080 IF S <> V THEN 2120
    if(S_int!=V_int) goto Lbl_02120;
    // 02090 IF Z = 1 THEN 2170
    if(Z_int==1) goto Lbl_02170;
    // 02100 LET Q = 1
    Q_int = 1;
    // 02110 GOTO 2130
    goto Lbl_02130;

  Lbl_02120:
    // 02120 IF W(R,S+1) <> 0 THEN 2170
    if(W_int_arr[(int)R_int][(int)S_int+1]!=0) goto Lbl_02170;

  Lbl_02130:
    // 02130 LET X = INT(RND*2+1)
    X_int = INT(RND()*2+1);
    // 02140 REM                          LEFT,DOWN
    //                          left,down
    // 02150 ON X GOTO 2700,2940
    switch((int)(X_int)){
        case 1: goto Lbl_02700;
        case 2: goto Lbl_02940;
        default: break; 
    };
    // 02160 REM                          LEFT
    //                          left

  Lbl_02170:
    // 02170 GOTO 2700
    goto Lbl_02700;

  Lbl_02180:
    // 02180 IF S-1 = 0 THEN 2430
    if(S_int-1==0) goto Lbl_02430;
    // 02190 IF W(R,S-1) <> 0 THEN 2430
    if(W_int_arr[(int)R_int][(int)S_int-1]!=0) goto Lbl_02430;
    // 02200 IF R=H THEN 2330
    if(R_int==H_int) goto Lbl_02330;
    // 02210 IF W(R+1,S) <> 0 THEN 2330
    if(W_int_arr[(int)R_int+1][(int)S_int]!=0) goto Lbl_02330;
    // 02220 IF S<> V THEN 2260
    if(S_int!=V_int) goto Lbl_02260;
    // 02230 IF Z = 1 THEN 2300
    if(Z_int==1) goto Lbl_02300;
    // 02240 LET Q = 1
    Q_int = 1;
    // 02250 GOTO 2270
    goto Lbl_02270;

  Lbl_02260:
    // 02260 IF W(R,S+1) <> 0 THEN 2300
    if(W_int_arr[(int)R_int][(int)S_int+1]!=0) goto Lbl_02300;

  Lbl_02270:
    // 02270 LET X = INT(RND*3+1)
    X_int = INT(RND()*3+1);
    // 02280 REM                         UP,RIGHT,DOWN
    //                         up,right,down
    // 02290 ON X GOTO 2770,2840,2940
    switch((int)(X_int)){
        case 1: goto Lbl_02770;
        case 2: goto Lbl_02840;
        case 3: goto Lbl_02940;
        default: break; 
    };

  Lbl_02300:
    // 02300 LET X = INT(RND*2+1)
    X_int = INT(RND()*2+1);
    // 02310 REM                         UP,RIGHT
    //                         up,right
    // 02320 ON X GOTO 2770,2840
    switch((int)(X_int)){
        case 1: goto Lbl_02770;
        case 2: goto Lbl_02840;
        default: break; 
    };

  Lbl_02330:
    // 02330 IF S <> V THEN 2370
    if(S_int!=V_int) goto Lbl_02370;
    // 02340 IF Z = 1 THEN 2420
    if(Z_int==1) goto Lbl_02420;
    // 02350 LET Q = 1
    Q_int = 1;
    // 02360 GOTO 2380
    goto Lbl_02380;

  Lbl_02370:
    // 02370 IF W(R,S+1) <> 0 THEN 2420
    if(W_int_arr[(int)R_int][(int)S_int+1]!=0) goto Lbl_02420;

  Lbl_02380:
    // 02380 LET X = INT(RND*2+1)
    X_int = INT(RND()*2+1);
    // 02390 REM                         UP,DOWN
    //                         up,down
    // 02400 ON X GOTO 2770,2940
    switch((int)(X_int)){
        case 1: goto Lbl_02770;
        case 2: goto Lbl_02940;
        default: break; 
    };
    // 02410 REM                         UP
    //                         up

  Lbl_02420:
    // 02420 GOTO 2770
    goto Lbl_02770;

  Lbl_02430:
    // 02430 IF R = H THEN 2550
    if(R_int==H_int) goto Lbl_02550;
    // 02440 IF W(R+1,S) <> 0 THEN 2550
    if(W_int_arr[(int)R_int+1][(int)S_int]!=0) goto Lbl_02550;
    // 02450 IF S <> V THEN 2490
    if(S_int!=V_int) goto Lbl_02490;
    // 02460 IF Z = 1 THEN 2540
    if(Z_int==1) goto Lbl_02540;
    // 02470 LET Q = 1
    Q_int = 1;
    // 02480 GOTO 2500
    goto Lbl_02500;

  Lbl_02490:
    // 02490 IF W(R,S+1) <> 0 THEN 2540
    if(W_int_arr[(int)R_int][(int)S_int+1]!=0) goto Lbl_02540;

  Lbl_02500:
    // 02500 LET X = INT(RND*2+1)
    X_int = INT(RND()*2+1);
    // 02510 REM                         RIGHT,DOWN
    //                         right,down
    // 02520 ON X GOTO 2840,2940
    switch((int)(X_int)){
        case 1: goto Lbl_02840;
        case 2: goto Lbl_02940;
        default: break; 
    };
    // 02530 REM                         RIGHT
    //                         right

  Lbl_02540:
    // 02540 GOTO 2840
    goto Lbl_02840;

  Lbl_02550:
    // 02550 IF S <> V THEN 2590
    if(S_int!=V_int) goto Lbl_02590;
    // 02560 IF Z = 1 THEN 2630
    if(Z_int==1) goto Lbl_02630;
    // 02570 LET Q = 1
    Q_int = 1;
    // 02580 GOTO 2610
    goto Lbl_02610;

  Lbl_02590:
    // 02590 IF W(R,S+1) <> 0 THEN 2630
    if(W_int_arr[(int)R_int][(int)S_int+1]!=0) goto Lbl_02630;
    // 02600 REM                         DOWN
    //                         down

  Lbl_02610:
    // 02610 GOTO 2940
    goto Lbl_02940;
    // 02620 REM                         BLOCKED
    //                         blocked

  Lbl_02630:
    // 02630 GOTO 3140
    goto Lbl_03140;
    
    
    // 02660 REM                          STEPS 13900 THRU 18100 MAKE A RANDOM
    //                          steps 13900 thru 18100 make a random
    // 02670 REM                          CHOICE OF AVAILABLE PATHS.
    //                          choice of available paths.
    
    

  Lbl_02700:
    // 02700 LET W(R-1,S) = C
    W_int_arr[(int)R_int-1][(int)S_int] = C_int;
    // 02710 LET C = C+1
    C_int = C_int+1;
    // 02720 LET V(R-1,S) = 2
    V_int_arr[(int)R_int-1][(int)S_int] = 2;
    // 02730 LET R = R-1
    R_int = R_int-1;
    // 02740 IF C = H*V+1 THEN 3160
    if(C_int==H_int*V_int+1) goto Lbl_03160;
    // 02750 LET Q = 0
    Q_int = 0;
    // 02760 GOTO 1750
    goto Lbl_01750;

  Lbl_02770:
    // 02770 LET W(R,S-1) = C
    W_int_arr[(int)R_int][(int)S_int-1] = C_int;
    // 02780 LET C = C+1
    C_int = C_int+1;
    // 02790 LET V(R,S-1) = 1
    V_int_arr[(int)R_int][(int)S_int-1] = 1;
    // 02800 LET S = S-1
    S_int = S_int-1;
    // 02810 IF C = H*V+1 THEN 3160
    if(C_int==H_int*V_int+1) goto Lbl_03160;
    // 02820 LET Q = 0
    Q_int = 0;
    // 02830 GOTO 1750
    goto Lbl_01750;

  Lbl_02840:
    // 02840 LET W(R+1,S) = C
    W_int_arr[(int)R_int+1][(int)S_int] = C_int;
    // 02850 LET C = C+1
    C_int = C_int+1;
    // 02860 IF V(R,S) = 0 THEN 2890
    if(V_int_arr[(int)R_int][(int)S_int]==0) goto Lbl_02890;
    // 02870 LET V(R,S) = 3
    V_int_arr[(int)R_int][(int)S_int] = 3;
    // 02880 GOTO 2900
    goto Lbl_02900;

  Lbl_02890:
    // 02890 LET V(R,S) = 2
    V_int_arr[(int)R_int][(int)S_int] = 2;

  Lbl_02900:
    // 02900 LET R = R+1
    R_int = R_int+1;
    // 02910 IF C = H*V+1 THEN 3160
    if(C_int==H_int*V_int+1) goto Lbl_03160;
    // 02920 LET Q = 0
    Q_int = 0;
    // 02930 GOTO 2180
    goto Lbl_02180;

  Lbl_02940:
    // 02940 IF Q = 1 THEN 3040
    if(Q_int==1) goto Lbl_03040;
    // 02950 LET W (R,S+1) = C
    W_int_arr[(int)R_int][(int)S_int+1] = C_int;
    // 02960 LET C = C+1
    C_int = C_int+1;
    // 02970 IF V(R,S) = 0 THEN 3000
    if(V_int_arr[(int)R_int][(int)S_int]==0) goto Lbl_03000;
    // 02980 LET V(R,S) = 3
    V_int_arr[(int)R_int][(int)S_int] = 3;
    // 02990 GOTO 3010
    goto Lbl_03010;

  Lbl_03000:
    // 03000 LET V(R,S) = 1
    V_int_arr[(int)R_int][(int)S_int] = 1;

  Lbl_03010:
    // 03010 LET S = S+1
    S_int = S_int+1;
    // 03020 IF C = H*V+1 THEN 3160
    if(C_int==H_int*V_int+1) goto Lbl_03160;
    // 03030 GOTO 1750
    goto Lbl_01750;

  Lbl_03040:
    // 03040 LET Z = 1
    Z_int = 1;
    // 03050 IF V(R,S) = 0 THEN 3090
    if(V_int_arr[(int)R_int][(int)S_int]==0) goto Lbl_03090;
    // 03060 LET V(R,S) = 3
    V_int_arr[(int)R_int][(int)S_int] = 3;
    // 03070 LET Q = 0
    Q_int = 0;
    // 03080 GOTO 3140
    goto Lbl_03140;

  Lbl_03090:
    // 03090 LET V(R,S) = 1
    V_int_arr[(int)R_int][(int)S_int] = 1;
    // 03100 LET Q = 0
    Q_int = 0;
    // 03110 LET R = 1
    R_int = 1;
    // 03120 LET S = 1
    S_int = 1;
    // 03130 GOTO 1740
    goto Lbl_01740;

  Lbl_03140:
    // 03140 GOTO 1580
    goto Lbl_01580;
    // 03150 REM                         PRINTS OUT THE MAZE FROM HERE ON.
    //                         prints out the maze from here on.

  Lbl_03160:
    // 03160 FOR J = 1 TO V
    for(J_int=1;J_int<=V_int;J_int++){
        // 03170  PRINT "I";
        MyFpf(stdout,"i");
        // 03180  FOR I = 1 TO H
        for(I_int=1;I_int<=H_int;I_int++){
            // 03190  IF V(I,J) < 2 THEN 3220
            if(V_int_arr[(int)I_int][(int)J_int]<2) goto Lbl_03220;
            // 03200   PRINT "   ";
            MyFpf(stdout,"   ");
            // 03210   GOTO 3230
            goto Lbl_03230;

  Lbl_03220:
            // 03220   PRINT "  I";
            MyFpf(stdout,"  i");

  Lbl_03230:
            // 03230  NEXT I
        }; // End-For(I_int)
        // 03240  PRINT
        MyFpf(stdout,"\n");
        // 03250  FOR I = 1 TO H
        for(I_int=1;I_int<=H_int;I_int++){
            // 03260   IF V(I,J) = 0 THEN 3300
            if(V_int_arr[(int)I_int][(int)J_int]==0) goto Lbl_03300;
            // 03270   IF V(I,J) = 2 THEN 3300
            if(V_int_arr[(int)I_int][(int)J_int]==2) goto Lbl_03300;
            // 03280   PRINT ":  ";
            MyFpf(stdout,":  ");
            // 03290   GOTO 3310
            goto Lbl_03310;

  Lbl_03300:
            // 03300   PRINT ":--";
            MyFpf(stdout,":--");

  Lbl_03310:
            // 03310  NEXT I
        }; // End-For(I_int)
        // 03320 PRINT ":"
        MyFpf(stdout,":\n");
        // 03330 NEXT J
    }; // End-For(J_int)
    // 03340 END
};

//---------------------------------------------------------------------------
// End of $RCSfile: Maze.cpp,v $ 
//---------------------------------------------------------------------------
