/*
 * Title: Display the annotated BASIC Listing (1)
 *
 *  Listing of D:\Dev\BasicGames\Translator\basic\Othelo.bas: 
 *
               +----+---- Routine IDs (Empty field=Inaccessible code, A=Main program).
               |    | +-- Target status (G-GOSUB, T-GOTO, B-Both GOSUB and GOTO)
      Program  |    | |
      Address  v    v v Original BASIC statement
    ---------- ------ - ------------------------------------------------------------------------------
    0x00cdbabc      A   01000 REM********		OTHELLO          BYTE VOL. 2, NUMBER 10 (OCT. 1977)
    0x00cdbb60      A   01010 REM********		PLAYS THE GAME OTHELLO WITH TWO STRATEGIES
    0x00cdbbf0      A   01020 REM********		1. TAKE THE MAX. NUMBER OF PIECES
    0x00cdbc88      A   01030 REM********		2. ADD A BONUS FOR OUTSIDE POSITION
    0x00cdbd30      A   01040 REM********		BOARD IS THE ARRAY A, BOUNDED BY 0'S (BLANKS)
    0x00cdbd7c      A   01050 REM********		A = 0 FOR EMPTY SQUARE
    0x00cdbdc8      A   01060 REM********		A = B FOR BLACK SQUARE
    0x00cdbe44      A   01070 REM********		A = W FOR WHITE SQUARE
    0x00cdbef0      A   01080 REM********		I AND J ARE ALWAYS USED FOR ROW/COLUMN INDICES
    0x00cdca18      A   01090 REM********		I1 AND J4 STORE INCREMENTS TO THE 8 NEIGHBOURS
    0x00cdcac8      A   01100 REM********		C$ AND D$ STORE CHARACTERS A-H,X,...,O FOR OUTPUT
    0x00cdcf8c      A   01110 DIM A(9,9),I4(8),J4(8),C$(8),D$(2)
    0x00cdcfc4      A   01120 REM********		
    0x00cdd0c8      A   01130 PRINT "GREETINGS FROM OTHELLO!"
    0x00cdd1a4      A   01140 PRINT "DO YOU WANT INSTRUCTIONS (Y OR N)";
    0x00cdd25c      A T 01150 INPUT X$
    0x00cdd338      A   01160 IF X$ = "N" THEN 1380
    0x00cdd438      A   01170 IF X$ <> "Y" THEN 1150
    0x00cdd4b4      A   01180 PRINT
    0x00cdd5b8      A   01190 PRINT "OTHELLO IS PLAYED ON AN 8X8 CHECKER BOARD"
    0x00cdd6c4      A   01200 PRINT "ROWS ARE NUMBERED FROM 1 TO 8 AND COLUMNS FROM A TO H"
    0x00cdd7d0      A   01210 PRINT" THE INITIAL CONFIGURATION IS ALL BLANK EXCEPT FOR"
    0x00cdd8b8      A   01220 PRINT "THE CENTER FOUR SQUARES, WHICH FORM THE PATTERN:"
    0x00cdd984      A   01230 PRINT "               O X"
    0x00cdda3c      A   01240 PRINT "               X O"
    0x00cddab4      A   01250 PRINT
    0x00cddbc8      A   01260 PRINT "TRY TO PLACE YOUR PIECE SO THAT IT WILL 'OUTFLANK' MINE"
    0x00cddcd8      A   01270 PRINT "THEREBY CREATING A HORIZONTAL, VERTICAL, OR DIAGONAL "
    0x00cdddec      A   01280 PRINT "RUN OF MY PIECES BOUNDED AT EACH END BY AT LEAST ONE "
    0x00cdded0      A   01290 PRINT "OF YOURS.  THIS WILL 'FLIP' MY PIECES, TURNING THEM INTO"
    0x00cddfb4      A   01300 PRINT "YOURS."
    0x00cde0c4      A   01310 PRINT"     NOTE: YOU MUST CAPTURE AT LEAST ONE OF MY PIECES"
    0x00cde1cc      A   01320 PRINT "IN THIS WAY IF IT IS AT ALL POSSIBLE.  IF IT IS NOT"
    0x00cde3c8      A   01330 PRINT "POSSIBLE, YOU FORFEIT YOUR TURN BY ENTERING"
    0x00cde4a0      A   01340 PRINT "     0,0   FOR YOUR ROW,COLUMN MOVE"
    0x00cde550      A   01350 PRINT " GOOD LUCK!"
    0x00cde594      A   01360 PRINT
    0x00cde5d4      A   01370 REM********		
    0x00cde6f0      A T 01380 PRINT "SHOULD I WAIT BEFORE MAKING MY MOVES (Y OR N)";
    0x00cde7f8      A   01390 F2 = 0
    0x00cde900      A   01400 F9 = 1
    0x00cde970      A T 01410 INPUT X$
    0x00cdea4c      A   01420 IF X$ = "N" THEN 1460
    0x00cdeb50      A   01430 IF X$ <> "Y" THEN  1410
    0x00cdec5c      A   01440 F2 = 1
    0x00cded50      A   01450         PRINT "OK.  TYPING ANY CHARACTER WILL LET ME GO"
    0x00cdee30      A T 01460 PRINT "SHOULD I PLAY MY BEST STRATEGY (Y OR N)";
    0x00cdef3c      A   01470 S2 = 0
    0x00cdefac      A T 01480 INPUT X$
    0x00cdf088      A   01490 IF X$ = "N" THEN 1520
    0x00cdf188      A   01500 IF X$ <> "Y" THEN 1480
    0x00cdf260      A   01510 S2 = 2
    0x00cdf364      A T 01520 B = -1
    0x00cdf470      A   01530 W = +1
    0x00cdf5e8      A   01540 D$(B +1) ="X"
    0x00cdf798      A   01550 D$(0 +1) = "."
    0x00cdf910      A   01560 D$(W + 1) ="O"
    0x00cdfa7c      A   01570 FOR K = 1 TO 8
    0x00cdfb0c      A   01580     READ I4(K)
    0x00cdfb58      A   01590 NEXT K
    0x00cdff18      A   01600 DATA 0,-1,-1,-1,0,1,1,1
    0x00ce0040      A   01610 FOR K=1 TO 8
    0x00ce00d0      A   01620     READ J4(K)
    0x00ce011c      A   01630 NEXT K
    0x00ce04dc      A   01640 DATA 1,1,0,-1,-1,-1,0,1
    0x00ce0808      A   01650 FOR K = 1 TO 8
    0x00ce0898      A   01660     READ C$(K)
    0x00ce08e4      A   01670 NEXT K
    0x00ce0cb0      A   01680 DATA A,B,C,D,E,F,G,H
    0x00ce0cfc      A   01690 REM********		SET UP A NEW GAME
    0x00ce0e80      A T 01700 FOR I = 0 TO 9
    0x00ce0ff0      A   01710     FOR J = 0 TO 9
    0x00ce110c      A   01720 	A(I,J)=0
    0x00ce115c      A   01730     NEXT J
    0x00ce11b8      A   01740 NEXT I
    0x00ce1314      A   01750 A(4,4) = W
    0x00ce1460      A   01760 A(5,5) = W
    0x00ce15ac      A   01770 A(4,5) = B
    0x00ce16f4      A   01780 A(5,4) = B
    0x00ce17f8      A   01790 C1 = 2
    0x00ce18fc      A   01800 H1 = 2
    0x00ce1a00      A   01810 N1 = 4
    0x00ce1b1c      A   01820 Z =0
    0x00ce1b68      A   01830 REM********		HUMAN'S CHOICES
    0x00ce1c64      A   01840 PRINT "DO YOU WANT TO HAVE X OR O";
    0x00ce1d34      A   01850 C = W
    0x00ce1e04      A   01860 H = B
    0x00ce1e74      A T 01870 INPUT X$
    0x00ce1f50      A   01880 IF X$ = "X" THEN 1920
    0x00ce2050      A   01890 IF X$ <> "O" THEN 1870
    0x00ce20f0      A   01900 C = B
    0x00ce219c      A   01910 H = W
    0x00ce2274      A T 01920 PRINT "DO YOU WANT TO GO FIRST (Y OR N)";
    0x00ce22e0      A T 01930 INPUT X$
    0x00ce23f8      A   01940 PRINT CHR$(26)
    0x00ce24d4      A   01950 IF X$ = "N" THEN 2030
    0x00ce25d4      A   01960 IF X$ <> "Y" THEN 1930
    0x00ce2658      A   01970 REM********		PRINT INITIAL BOARD
    0x00ce26a4      A   01980 GOSUB 4320
    0x00ce26f0      A   01990 GO TO 2760
    0x00ce2738      A   02000 REM********		COMPUTER'S MOVE
    0x00ce2820      A T 02010 IF F2 = 0 THEN 2030
    0x00ce28a0      A   02020 INPUT X$
    0x00ce29b0      A T 02030 B1 = -1
    0x00ce2b20      A   02040 I3 = J3 = 0
    0x00ce2bec      A   02050 T1 = C
    0x00ce2cd4      A   02060 T2 = H
    0x00ce2d24      A   02070 REM********		SCAN FOR BLANK SQUARE
    0x00ce2e64      A   02080 FOR I = 1 TO 8
    0x00ce2fa0      A   02090     FOR J = 1 TO 8
    0x00ce30c4      A   02100 	IF A(I,J) <> 0 THEN 2390
    0x00ce3148      A   02110 	REM********		FOUND A BLANK SQUARE
    0x00ce31e8      A   02120 	REM********		DOES IT HAVE AN OPPONENT AS A NEIGHBOUR
    0x00ce3244      A   02130 	GOSUB 3840
    0x00ce3350      A   02140 	IF F1 = 0 THEN 2390
    0x00ce33e4      A   02150 	REM********		FOUND OPPONENT AS NEIGHBOUR
    0x00ce347c      A   02160 	REM********		HOW MANY OF HIS PIECES CAN WE FLIP?
    0x00ce34ec      A   02170 	REM********		DON'T DO IT NOW
    0x00ce3608      A   02180 	U = -1
    0x00ce366c      A   02190 	GOSUB 4040
    0x00ce36c4      A   02200 	REM********		EXTRA POINTS FOR BOUNDARY POSITION
    0x00ce37f0      A   02210 	IF S1 = 0 THEN 2390
    0x00ce3a64      A   02220 	IF (I-1) * (I-8) <> 0 THEN 2240
    0x00ce3b6c      A   02230 	S1 = S1 + S2
    0x00ce3dac      A T 02240 	IF (J-1) * (J-8) <> 0 THEN 2270
    0x00ce3ecc      A   02250 	S1 = S1 +S2
    0x00ce3f30      A   02260 	REM********		IS THIS BETTER THAN THE BEST FOUND SO FAR
    0x00cde1f8      A T 02270 	IF S1 < B1 THEN 2390
    0x00cde294      A   02280 	IF S1 > B1 THEN 2350
    0x00ce442c      A   02290 	REM********		A TIE; RANDOM DECISION
    0x00ce44d0      A   02300 	REM********		THE NEXT TWO EXECUTABLE STATEMENTS ARE FOR
    0x00ce4554      A   02310 	REM********		BASIC WITH RANDOM NUMBERS
    0x00ce46e8      A   02320 	R = RND(1)
    0x00ce47b4      A   02330 	IF R > .5 THEN 2390
    0x00ce4818      A   02340 	REM********		YES
    0x00ce48b4      A T 02350 	B1 = S1
    0x00ce4940      A   02360 	I3 = I
    0x00ce49e0      A   02370 	J3 = J
    0x00ce4a2c      A   02380 	REM********		END OF SCAN LOOP
    0x00ce4a8c      A T 02390     NEXT J
    0x00ce4ae8      A   02400 NEXT I
    0x00ce4b60      A   02410 REM********		COULD WE DO ANYTHING?
    0x00ce4c48      A   02420 IF B1 > 0 THEN 2510
    0x00ce4ca8      A   02430 REM********		NO
    0x00ce4dc0      A   02440 LET L = 18
    0x00ce4e18      A   02450 GOSUB 4490
    0x00ce4ee0      A   02460 PRINT "DAMN! HAVE TO FORFEIT MY MOVE!"
    0x00ce4fb0      A   02470 IF Z = 1 THEN 3370
    0x00ce508c      A   02480 Z = 1
    0x00ce50d8      A   02490 GO TO 2760
    0x00ce511c      A   02500 REM********		MAKE THE MOVE
    0x00ce51ec      A T 02510 Z = 0
    0x00ce52b0      A   02520 LET L=15
    0x00ce52fc      A   02530 GOSUB 4490
    0x00ce53c0      A   02540 PRINT "I WILL MOVE TO ";
    0x00ce5440      A   02550 PRINT I3;
    0x00ce5504      A   02560 PRINT " , ";
    0x00ce5590      A   02570 PRINT C$(J3)
    0x00ce561c      A   02580 I= I3
    0x00ce56a4      A   02590 J= J3
    0x00ce5768      A   02600 U= 1
    0x00ce57ac      A   02610 GOSUB 4040
    0x00ce58f8      A   02620 C1 = C1 + S1 + 1
    0x00ce59cc      A   02630 H1 = H1 - S1
    0x00ce5ad4      A   02640 N1 = N1 + 1
    0x00ce5b98      A   02650 LET L=16
    0x00ce5be4      A   02660 GOSUB 4490
    0x00ce5ca8      A   02670 PRINT " THAT GIVES ME : ";
    0x00ce5d34      A   02680 PRINT S1;
    0x00ce5e00      A   02690 PRINT " OF YOUR PIECES"
    0x00ce5e50      A   02700 REM********		PRINT OUT BOARD
    0x00ce5eb4      A   02710 GOSUB 4320
    0x00ce5f00      A   02720 REM********		TEST FOR END OF GAME
    0x00ce5fe8      A   02730 IF H1 = 0 THEN 3370
    0x00ce60dc      A   02740 IF N1 = 64 THEN 3370
    0x00ce6150      A   02750 REM********		HUMANS MOVE
    0x00ce61e4      A T 02760 T1 = H
    0x00ce6270      A   02770 T2 = C
    0x00ce6334      A   02780 LET L = 12
    0x00ce637c      A   02790 GOSUB 4490
    0x00ce6440      A T 02800 PRINT " YOUR MOVE";
    0x00ce64d8      A T 02810 INPUT I, X$
    0x00ce65a8      A   02820 IF I < 0 THEN 2810
    0x00ce6698      A   02830 IF I > 8 THEN 2810
    0x00ce678c      A   02840 IF I <> 0 THEN 2930
    0x00ce686c      A   02850 LET L = 18
    0x00ce68cc      A   02860 GOSUB 4490
    0x00ce6990      A   02870 PRINT "ARE YOU FORFEITING YOUR TURN Y OR N"
    0x00ce6a04      A   02880 INPUT X$
    0x00ce6ae0      A   02890 IF X$ <> "Y" THEN 2800
    0x00ce6bd0      A   02900 IF Z = 1 THEN 3370
    0x00ce6cac      A   02910 Z = 1
    0x00ce6cec      A   02920 GO TO 2010
    0x00ce6e1c      A T 02930 FOR J = 1 TO 8
    0x00ce6ee0      A   02940     IF C$(J) =X$ THEN 2980
    0x00ce6f48      A   02950 NEXT J
    0x00ce6fa8      A   02960 GO TO 2810
    0x00ce6ff0      A   02970 REM********		CHECK FOR BLANK
    0x00ce712c      A T 02980 IF A(I,J) = 0 THEN 3040
    0x00ce720c      A   02990 LET L = 18
    0x00ce7270      A   03000 GOSUB 4490
    0x00ce7338      A   03010 PRINT "SORRY, THAT SQUARE IS OCCUPIED, TRY AGAIN"
    0x00ce7394      A   03020 GO TO 2810
    0x00ce73e4      A   03030 REM********		CHECK FOR LEGAL NEIGHBOUR
    0x00ce743c      A T 03040 GOSUB 3840
    0x00ce7504      A   03050 IF F1 = 1 THEN 3110
    0x00ce75e4      A   03060 LET L = 18
    0x00ce7658      A   03070 GOSUB 4490
    0x00ce7744      A   03080 PRINT "SORRY, YOU ARE NOT NEXT TO ONE OF MY PIECES. TRY AGAIN.";
    0x00ce779c      A   03090 GO TO 2810
    0x00ce77e4      A   03100 REM********		CHECK IF LEGAL RUN
    0x00ce78b4      A T 03110 U = -1
    0x00ce78fc      A   03120 GOSUB 4040
    0x00ce79c4      A   03130 IF S1 > 0 THEN 3190
    0x00ce7aa4      A   03140 LET L = 18
    0x00ce7b08      A   03150 GOSUB 4490
    0x00ce7bd4      A   03160 PRINT "SORRY, THAT DOESN'T FLANK A ROW, TRY AGAIN"
    0x00ce7c3c      A   03170 GO TO 2810
    0x00ce7c94      A   03180 REM********		EVERYTHING LEGAL; MAKE HUMANS MOVE
    0x00ce7d64      A T 03190 Z = 0
    0x00ce7e28      A   03200 LET L = 13
    0x00ce7e74      A   03210 GOSUB 4490
    0x00ce7f38      A   03220 PRINT "THAT GIVES YOU";
    0x00ce7fc0      A   03230 PRINT S1;
    0x00ce0574      A   03240 PRINT " OF MY PIECES"
    0x00ce063c      A   03250 U = 1
    0x00ce0680      A   03260 GOSUB 4040
    0x00ce80cc      A   03270 H1 = H1 + S1 + 1
    0x00ce81a0      A   03280 C1 = C1 -S1
    0x00ce82bc      A   03290 N1 = N1 + 1
    0x00ce8308      A   03300 REM********		PRINT OUT BOARD
    0x00ce836c      A   03310 GOSUB 4320
    0x00ce83b8      A   03320 REM********		TEST FOR END OF GAME
    0x00ce84a0      A   03330 IF C1 = 0 THEN 3370
    0x00ce8594      A   03340 IF N1 = 64 THEN 3370
    0x00ce8604      A   03350 GO TO 2010
    0x00ce8650      A   03360 REM********		END OF GAME ; WRAPUP
    0x00ce8724      A T 03370 LET L = 18
    0x00ce8780      A   03380 GOSUB 4490
    0x00ce8840      A   03390 PRINT "FOR RESULTS ON GAME TYPE RETURN!!"
    0x00ce88b8      A   03400 INPUT X$
    0x00ce8a24      A   03410 PRINT CHR$(30),CHR$(26)
    0x00ce8ae8      A   03420 PRINT "YOU HAVE ";
    0x00ce8b78      A   03430 PRINT H1;
    0x00ce8c48      A   03440 PRINT " PIECES, AND I HAVE ";
    0x00ce8cd0      A   03450 PRINT C1;
    0x00ce8d90      A   03460 PRINT " PIECES--- "
    0x00ce8e28      A   03470 IF H1 = C1 THEN 3510
    0x00ce8ee4      A   03480 IF H1 > C1 THEN 3530
    0x00ce8fd0      A   03490 PRINT "SORRY, I WON THAT ONE."
    0x00ce901c      A   03500 GO TO 3540
    0x00ce90c8      A T 03510 PRINT " A TIE!!!!!"
    0x00ce9110      A   03520 GO TO 3720
    0x00ce91c0      A T 03530 PRINT "YOU WON!!!"
    0x00ce92a0      A T 03540 C1 = C1 - H1
    0x00ce936c      A   03550 IF C1 > 0 THEN 3570
    0x00ce941c      A   03560 C1 = -C1
    0x00ce9d94      A T 03570 C1 = (64 * C1)/ N1
    0x00ce9e64      A   03580 PRINT "THAT WAS A ";
    0x00ce9f34      A   03590 IF C1 < 11 THEN 3710
    0x00cea028      A   03600 IF C1 < 25 THEN 3690
    0x00cea11c      A   03610 IF C1 < 39 THEN 3670
    0x00cea210      A   03620 IF C1 < 53 THEN 3650
    0x00cea2f0      A   03630 PRINT " A PERFECT GAME!"
    0x00cea338      A   03640 GO TO 3720
    0x00cea3e0      A T 03650 PRINT "WALKAWAY!"
    0x00cea424      A   03660 GO TO 3720
    0x00cea4cc      A T 03670 PRINT "FIGHT!"
    0x00cea514      A   03680 GO TO 3720
    0x00cea5bc      A T 03690 PRINT "HOT GAME!"
    0x00cea604      A   03700 GO TO 3720
    0x00cea6a8      A T 03710 PRINT "SQUEAKER!"
    0x00cea700      A T 03720 PRINT
    0x00cea7d4      A   03730 PRINT"DO YOU WANT TO PLAY AGAIN";
    0x00cea848      A T 03740 INPUT X$
    0x00cea924      A   03750 IF X$ = "Y" THEN 1700
    0x00ceaa24      A   03760 IF X$ <> "N" THEN 3740
    0x00ceab08      A   03770 PRINT "THANKS FOR PLAYING."
    0x00ceab34      A   03780 STOP
    0x00ceab80     B    03790 REM********		
    0x00ceac18     B    03800 REM********		SUBROUTINE: TEST FOR PROPER NEIGHBOUR
    0x00ceac78     B    03810 REM********		ASSUMES:
    0x00ceacfc     B    03820 REM********		I,J LOCATES A BLANK SQUARE
    0x00cead9c     B    03830 REM********		YOU HOPE TO SEE AN ADJACENT  T2 (= -T1)
    0x00ceaf28     B  G 03840 FOR I1 =  -1 TO 1
    0x00ceb0b0     B    03850     FOR J1 = -1 TO 1
    0x00ceb224     B    03860 	IF  A(I+I1,J+J1) = T2 THEN 3930
    0x00ceb294     B    03870     NEXT J1
    0x00ceb2f4     B    03880 NEXT I1
    0x00ceb35c     B    03890 REM********		NO T2 FOUND
    0x00ceb428     B    03900 F1 = 0
    0x00ceb450     B    03910 RETURN
    0x00ceb4ac     B    03920 REM********		SUCCESS
    0x00ceb578     B  T 03930 F1 = 1
    0x00ceb5a0     B    03940 RETURN
    0x00ceb624    C     03950 REM********		SUBROUTINE SCORE AND UPDATE
    0x00ceb684    C     03960 REM********		ASSUMES;
    0x00ceb728    C     03970 REM********		(I,J) IS A TENTATIVE PLACE FOR A PIECE T1.
    0x00ceb7cc    C     03980 REM********		WANT RUNS OF T2 = -T1, TERMINATED BY A T1.
    0x00ceb870    C     03990 REM********		IF U IS TRUE (1), MARK THOSE RUNS AS T1'S.
    0x00ceb910    C     04000 REM********		RETURN SUM OF ALL RUNS (T2'S ONLY) IN S1.
    0x00ceb9b8    C     04010 REM********		MAIN PROGRAM CONTAINS THE FOLLOWING ARRAYS:
    0x00ceba40    C     04020 REM********		I4:  0 -1 -1 -1  0  1  1  1
    0x00cebac8    C     04030 REM********		J4:  1  1  0 -1 -1 -1  0  1
    0x00cebb9c    C   G 04040 S1 = 0
    0x00cebcc4    C     04050 FOR K = 1 TO 8
    0x00cebdc8    C     04060     I5 = I4(K)
    0x00cebec8    C     04070     J5 = J4(K)
    0x00ce4000    C     04080     I6 = I + I5
    0x00ce40fc    C     04090     J6 = J + J5
    0x00ce421c    C     04100     S3 = 0
    0x00ce4300    C     04110     IF A(I6,J6) <> T2 THEN 4290
    0x00ce4378    C     04120     REM			LOOP THROUGH THE RUN
    0x00cec0b4    C   T 04130     S3 = S3 + 1
    0x00cec18c    C     04140     I6 = I6 + I5
    0x00cec274    C     04150     J6 = J6 + J5
    0x00cec358    C     04160     IF A (I6,J6) = T1 THEN 4190
    0x00cec4a4    C     04170     IF A(I6,J6) = 0 THEN 4290
    0x00cec4f0    C     04180     GO TO 4130
    0x00cec5cc    C   T 04190     S1 = S1 + S3
    0x00cec698    C     04200     IF U <> 1 THEN 4290
    0x00cec700    C     04210     REM			UPDATE BOARD
    0x00cec79c    C     04220     I6 = I
    0x00cec834    C     04230     J6 = J
    0x00cec968    C     04240     FOR K1 = 0 TO S3
    0x00ceca50    C     04250 	A(I6,J6) = T1
    0x00cecb24    C     04260 	I6 = I6 + I5
    0x00cecbf8    C     04270 	J6 = J6 + J5
    0x00cecc48    C     04280     NEXT K1
    0x00cecca4    C   T 04290 NEXT K
    0x00ceccd8    C     04300 RETURN
    0x00cecd54   D      04310 REM********		SUBROUTINE TO PRINT BOARD
    0x00cece2c   D    G 04320 PRINT CHR$(30)
    0x00cecf00   D      04330 LET L = 18
    0x00cecfcc   D      04340 IF F9 = 1 GO TO 4370
    0x00ced024   D      04350 GOSUB 4570
    0x00ced0e8   D      04360 LET F9 = 1
    0x00ced1c0   D    T 04370 PRINT CHR$(30)
    0x00ced280   D      04380 PRINT "    A B C D E F G H"
    0x00ced3ac   D      04390 FOR I = 1 TO 8
    0x00ced434   D      04400     PRINT I;
    0x00ced560   D      04410     FOR J = 1 TO 8
    0x00ced630   D      04420 	PRINT " ";
    0x00ced7a0   D      04430 	PRINT D$(A(I,J)+1);
    0x00ced7f4   D      04440     NEXT J
    0x00ced83c   D      04450     PRINT
    0x00ced890   D      04460 NEXT I
    0x00ced8d4   D      04470 PRINT
    0x00ced900   D      04480 RETURN
    0x00ced968  E     G 04490 REM********		***	SPACE		***
    0x00ceda48  E       04500 PRINT CHR$(30)
    0x00cedb7c  E       04510 FOR I9 = 1 TO L
    0x00cedbc0  E       04520     PRINT
    0x00cedc14  E       04530 NEXT I9
    0x00cedcfc  E       04540 IF L <> 18 GO TO 4560
    0x00ceddd4  E       04550 F9 = 0
    0x00ceddfc  E     T 04560 RETURN
    0x00cede68 F      G 04570 REM********		***	BLANK OUT	***
    0x00cedebc F        04580 GOSUB 4490
    0x00cee048 F        04590 PRINT TAB(60);" "
    0x00cee18c F        04600 PRINT TAB(60);" "
    0x00cee1b8 F        04610 RETURN
    0x00cee1e8      A   04620 END
 */

/*
 * Line reference table:
 *

    Target
   Line Num.    Referencing line number (Reference is T-GOTO or G-GOSUB).
   ---------    -------------------------------------------------------------------
     01150      01170T
     01380      01160T
     01410      01430T
     01460      01420T
     01480      01500T
     01520      01490T
     01700      03750T
     01870      01890T
     01920      01880T
     01930      01960T
     02010      02920T, 03350T
     02030      01950T, 02010T
     02240      02220T
     02270      02240T
     02350      02280T
     02390      02100T, 02140T, 02210T, 02270T, 02330T
     02510      02420T
     02760      01990T, 02490T
     02800      02890T
     02810      02820T, 02830T, 02960T, 03020T, 03090T, 03170T
     02930      02840T
     02980      02940T
     03040      02980T
     03110      03050T
     03190      03130T
     03370      02470T, 02730T, 02740T, 02900T, 03330T, 03340T
     03510      03470T
     03530      03480T
     03540      03500T
     03570      03550T
     03650      03620T
     03670      03610T
     03690      03600T
     03710      03590T
     03720      03520T, 03640T, 03660T, 03680T, 03700T
     03740      03760T
     03840      02130G, 03040G
     03930      03860T
     04040      02190G, 02610G, 03120G, 03260G
     04130      04180T
     04190      04160T
     04290      04110T, 04170T, 04200T
     04320      01980G, 02710G, 03310G
     04370      04340T
     04490      02450G, 02530G, 02660G, 02790G, 02860G, 03000G, 03070G, 03150G, 
                03210G, 03380G, 04580G
     04560      04540T
     04570      04350G

 */

/* 
 * Routine Start, Target, Return and End Program Addresses 
 * 

  Rtn    Start       Target       Return         End    
  --- ----------   ----------   ----------   ---------- 
   A) 0x00ce9444   0x00ce9444   0x00ce99ec   0x00ce99ec 
   B) 0x00ce98a0   0x00ce98b4   0x00ce98d0   0x00ce98dc 
   C) 0x00ce98e0   0x00ce9904   0x00ce996c   0x00ce996c 
   D) 0x00ce9970   0x00ce9974   0x00ce99b4   0x00ce99b4 
   E) 0x00ce99b8   0x00ce99b8   0x00ce99d4   0x00ce99d4 
   F) 0x00ce99d8   0x00ce99d8   0x00ce99e8   0x00ce99e8 

    NOTE: Routine B overlaps, or is tangled with, routine A!
    NOTE: Routine C overlaps, or is tangled with, routine A!
    NOTE: Routine D overlaps, or is tangled with, routine A!
    NOTE: Routine E overlaps, or is tangled with, routine A!
    NOTE: Routine F overlaps, or is tangled with, routine A!

 */


/* 
 * Routine Start, Target, Return and End Program Addresses 
 * 

  Rtn    Start       Target       Return         End    
  --- ----------   ----------   ----------   ---------- 
   A) 0x00ce9444   0x00ce9444   0x00ce99ec   0x00ce99ec 
   B) 0x00ce98a0   0x00ce98b4   0x00ce98d0   0x00ce98dc 
   C) 0x00ce98e0   0x00ce9904   0x00ce996c   0x00ce996c 
   D) 0x00ce9970   0x00ce9974   0x00ce99b4   0x00ce99b4 
   E) 0x00ce99b8   0x00ce99b8   0x00ce99d4   0x00ce99d4 
   F) 0x00ce99d8   0x00ce99d8   0x00ce99e8   0x00ce99e8 

    NOTE: Routine B overlaps, or is tangled with, routine A!
    NOTE: Routine C overlaps, or is tangled with, routine A!
    NOTE: Routine D overlaps, or is tangled with, routine A!
    NOTE: Routine E overlaps, or is tangled with, routine A!
    NOTE: Routine F overlaps, or is tangled with, routine A!

 */



/*
 * Free line number map.
 *
     Start    End    # Lines in Gap
     -----   -----   ------------------
     00000 - 00990     100 
     03790 - 04610      83 
     04630 - 04630       1 
     05470 - 10000    4540 

 */



/*
 *  Symbol Table Listing for '..\basic\Othelo.bas'
 *
    A     Array    Integer     {0,10} {0,10} 
    B              Integer 
    B1             Integer 
    C              Integer 
    C$    Array    String      {0,9} 
    C1             Integer 
    CHR$  Function String      args=1, int   
    D$    Array    String      {0,3} 
    F1             Integer 
    F2             Integer 
    F9             Integer 
    H              Integer 
    H1             Integer 
    I              Integer 
    I1             Integer 
    I3             Integer 
    I4    Array    Integer     {0,9} 
    I5             Integer 
    I6             Integer 
    I9             Integer 
    J              Integer 
    J1             Integer 
    J3             Integer 
    J4    Array    Integer     {0,9} 
    J5             Integer 
    J6             Integer 
    K              Integer 
    K1             Integer 
    L              Integer 
    N1             Integer 
    R              Integer 
    RND   Function Integer     args=1, int   
    S1             Integer 
    S2             Integer 
    S3             Integer 
    T1             Integer 
    T2             Integer 
    TAB   Function String      args=1, 
    U              Integer 
    W              Integer 
    X$             String  
    Z              Integer 

 */


/*
 * Title: Display of final 'clean' BASIC listing.
 *
 *  Listing of D:\Dev\BasicGames\Translator\basic\Othelo.bas: 
 *
               +----+---- Routine IDs (Empty field=Inaccessible code, A=Main program).
               |    | +-- Target status (G-GOSUB, T-GOTO, B-Both GOSUB and GOTO)
      Program  |    | |
      Address  v    v v Original BASIC statement
    ---------- ------ - ------------------------------------------------------------------------------
    0x00cdbabc      A   01000 REM********		OTHELLO          BYTE VOL. 2, NUMBER 10 (OCT. 1977)
    0x00cdbb60      A   01010 REM********		PLAYS THE GAME OTHELLO WITH TWO STRATEGIES
    0x00cdbbf0      A   01020 REM********		1. TAKE THE MAX. NUMBER OF PIECES
    0x00cdbc88      A   01030 REM********		2. ADD A BONUS FOR OUTSIDE POSITION
    0x00cdbd30      A   01040 REM********		BOARD IS THE ARRAY A, BOUNDED BY 0'S (BLANKS)
    0x00cdbd7c      A   01050 REM********		A = 0 FOR EMPTY SQUARE
    0x00cdbdc8      A   01060 REM********		A = B FOR BLACK SQUARE
    0x00cdbe44      A   01070 REM********		A = W FOR WHITE SQUARE
    0x00cdbef0      A   01080 REM********		I AND J ARE ALWAYS USED FOR ROW/COLUMN INDICES
    0x00cdca18      A   01090 REM********		I1 AND J4 STORE INCREMENTS TO THE 8 NEIGHBOURS
    0x00cdcac8      A   01100 REM********		C$ AND D$ STORE CHARACTERS A-H,X,...,O FOR OUTPUT
    0x00cdcf8c      A   01110 DIM A(9,9),I4(8),J4(8),C$(8),D$(2)
    0x00cdcfc4      A   01120 REM********		
    0x00cdd0c8      A   01130 PRINT "GREETINGS FROM OTHELLO!"
    0x00cdd1a4      A   01140 PRINT "DO YOU WANT INSTRUCTIONS (Y OR N)";
    0x00cdd25c      A T 01150 INPUT X$
    0x00cdd338      A   01160 IF X$ = "N" THEN 1380
    0x00cdd438      A   01170 IF X$ <> "Y" THEN 1150
    0x00cdd4b4      A   01180 PRINT
    0x00cdd5b8      A   01190 PRINT "OTHELLO IS PLAYED ON AN 8X8 CHECKER BOARD"
    0x00cdd6c4      A   01200 PRINT "ROWS ARE NUMBERED FROM 1 TO 8 AND COLUMNS FROM A TO H"
    0x00cdd7d0      A   01210 PRINT" THE INITIAL CONFIGURATION IS ALL BLANK EXCEPT FOR"
    0x00cdd8b8      A   01220 PRINT "THE CENTER FOUR SQUARES, WHICH FORM THE PATTERN:"
    0x00cdd984      A   01230 PRINT "               O X"
    0x00cdda3c      A   01240 PRINT "               X O"
    0x00cddab4      A   01250 PRINT
    0x00cddbc8      A   01260 PRINT "TRY TO PLACE YOUR PIECE SO THAT IT WILL 'OUTFLANK' MINE"
    0x00cddcd8      A   01270 PRINT "THEREBY CREATING A HORIZONTAL, VERTICAL, OR DIAGONAL "
    0x00cdddec      A   01280 PRINT "RUN OF MY PIECES BOUNDED AT EACH END BY AT LEAST ONE "
    0x00cdded0      A   01290 PRINT "OF YOURS.  THIS WILL 'FLIP' MY PIECES, TURNING THEM INTO"
    0x00cddfb4      A   01300 PRINT "YOURS."
    0x00cde0c4      A   01310 PRINT"     NOTE: YOU MUST CAPTURE AT LEAST ONE OF MY PIECES"
    0x00cde1cc      A   01320 PRINT "IN THIS WAY IF IT IS AT ALL POSSIBLE.  IF IT IS NOT"
    0x00cde3c8      A   01330 PRINT "POSSIBLE, YOU FORFEIT YOUR TURN BY ENTERING"
    0x00cde4a0      A   01340 PRINT "     0,0   FOR YOUR ROW,COLUMN MOVE"
    0x00cde550      A   01350 PRINT " GOOD LUCK!"
    0x00cde594      A   01360 PRINT
    0x00cde5d4      A   01370 REM********		
    0x00cde6f0      A T 01380 PRINT "SHOULD I WAIT BEFORE MAKING MY MOVES (Y OR N)";
    0x00cde7f8      A   01390 F2 = 0
    0x00cde900      A   01400 F9 = 1
    0x00cde970      A T 01410 INPUT X$
    0x00cdea4c      A   01420 IF X$ = "N" THEN 1460
    0x00cdeb50      A   01430 IF X$ <> "Y" THEN  1410
    0x00cdec5c      A   01440 F2 = 1
    0x00cded50      A   01450         PRINT "OK.  TYPING ANY CHARACTER WILL LET ME GO"
    0x00cdee30      A T 01460 PRINT "SHOULD I PLAY MY BEST STRATEGY (Y OR N)";
    0x00cdef3c      A   01470 S2 = 0
    0x00cdefac      A T 01480 INPUT X$
    0x00cdf088      A   01490 IF X$ = "N" THEN 1520
    0x00cdf188      A   01500 IF X$ <> "Y" THEN 1480
    0x00cdf260      A   01510 S2 = 2
    0x00cdf364      A T 01520 B = -1
    0x00cdf470      A   01530 W = +1
    0x00cdf5e8      A   01540 D$(B +1) ="X"
    0x00cdf798      A   01550 D$(0 +1) = "."
    0x00cdf910      A   01560 D$(W + 1) ="O"
    0x00cdfa7c      A   01570 FOR K = 1 TO 8
    0x00cdfb0c      A   01580     READ I4(K)
    0x00cdfb58      A   01590 NEXT K
    0x00cdff18      A   01600 DATA 0,-1,-1,-1,0,1,1,1
    0x00ce0040      A   01610 FOR K=1 TO 8
    0x00ce00d0      A   01620     READ J4(K)
    0x00ce011c      A   01630 NEXT K
    0x00ce04dc      A   01640 DATA 1,1,0,-1,-1,-1,0,1
    0x00ce0808      A   01650 FOR K = 1 TO 8
    0x00ce0898      A   01660     READ C$(K)
    0x00ce08e4      A   01670 NEXT K
    0x00ce0cb0      A   01680 DATA A,B,C,D,E,F,G,H
    0x00ce0cfc      A   01690 REM********		SET UP A NEW GAME
    0x00ce0e80      A T 01700 FOR I = 0 TO 9
    0x00ce0ff0      A   01710     FOR J = 0 TO 9
    0x00ce110c      A   01720 	A(I,J)=0
    0x00ce115c      A   01730     NEXT J
    0x00ce11b8      A   01740 NEXT I
    0x00ce1314      A   01750 A(4,4) = W
    0x00ce1460      A   01760 A(5,5) = W
    0x00ce15ac      A   01770 A(4,5) = B
    0x00ce16f4      A   01780 A(5,4) = B
    0x00ce17f8      A   01790 C1 = 2
    0x00ce18fc      A   01800 H1 = 2
    0x00ce1a00      A   01810 N1 = 4
    0x00ce1b1c      A   01820 Z =0
    0x00ce1b68      A   01830 REM********		HUMAN'S CHOICES
    0x00ce1c64      A   01840 PRINT "DO YOU WANT TO HAVE X OR O";
    0x00ce1d34      A   01850 C = W
    0x00ce1e04      A   01860 H = B
    0x00ce1e74      A T 01870 INPUT X$
    0x00ce1f50      A   01880 IF X$ = "X" THEN 1920
    0x00ce2050      A   01890 IF X$ <> "O" THEN 1870
    0x00ce20f0      A   01900 C = B
    0x00ce219c      A   01910 H = W
    0x00ce2274      A T 01920 PRINT "DO YOU WANT TO GO FIRST (Y OR N)";
    0x00ce22e0      A T 01930 INPUT X$
    0x00ce23f8      A   01940 PRINT CHR$(26)
    0x00ce24d4      A   01950 IF X$ = "N" THEN 2030
    0x00ce25d4      A   01960 IF X$ <> "Y" THEN 1930
    0x00ce2658      A   01970 REM********		PRINT INITIAL BOARD
    0x00ce26a4      A   01980 GOSUB 5159
    0x00ce26f0      A   01990 GO TO 2760
    0x00ce2738      A   02000 REM********		COMPUTER'S MOVE
    0x00ce2820      A T 02010 IF F2 = 0 THEN 2030
    0x00ce28a0      A   02020 INPUT X$
    0x00ce29b0      A T 02030 B1 = -1
    0x00ce2b20      A   02040 I3 = J3 = 0
    0x00ce2bec      A   02050 T1 = C
    0x00ce2cd4      A   02060 T2 = H
    0x00ce2d24      A   02070 REM********		SCAN FOR BLANK SQUARE
    0x00ce2e64      A   02080 FOR I = 1 TO 8
    0x00ce2fa0      A   02090     FOR J = 1 TO 8
    0x00ce30c4      A   02100 	IF A(I,J) <> 0 THEN 2390
    0x00ce3148      A   02110 	REM********		FOUND A BLANK SQUARE
    0x00ce31e8      A   02120 	REM********		DOES IT HAVE AN OPPONENT AS A NEIGHBOUR
    0x00ce3244      A   02130 	GOSUB 4639
    0x00ce3350      A   02140 	IF F1 = 0 THEN 2390
    0x00ce33e4      A   02150 	REM********		FOUND OPPONENT AS NEIGHBOUR
    0x00ce347c      A   02160 	REM********		HOW MANY OF HIS PIECES CAN WE FLIP?
    0x00ce34ec      A   02170 	REM********		DON'T DO IT NOW
    0x00ce3608      A   02180 	U = -1
    0x00ce366c      A   02190 	GOSUB 4799
    0x00ce36c4      A   02200 	REM********		EXTRA POINTS FOR BOUNDARY POSITION
    0x00ce37f0      A   02210 	IF S1 = 0 THEN 2390
    0x00ce3a64      A   02220 	IF (I-1) * (I-8) <> 0 THEN 2240
    0x00ce3b6c      A   02230 	S1 = S1 + S2
    0x00ce3dac      A T 02240 	IF (J-1) * (J-8) <> 0 THEN 2270
    0x00ce3ecc      A   02250 	S1 = S1 +S2
    0x00ce3f30      A   02260 	REM********		IS THIS BETTER THAN THE BEST FOUND SO FAR
    0x00cde1f8      A T 02270 	IF S1 < B1 THEN 2390
    0x00cde294      A   02280 	IF S1 > B1 THEN 2350
    0x00ce442c      A   02290 	REM********		A TIE; RANDOM DECISION
    0x00ce44d0      A   02300 	REM********		THE NEXT TWO EXECUTABLE STATEMENTS ARE FOR
    0x00ce4554      A   02310 	REM********		BASIC WITH RANDOM NUMBERS
    0x00ce46e8      A   02320 	R = RND(1)
    0x00ce47b4      A   02330 	IF R > .5 THEN 2390
    0x00ce4818      A   02340 	REM********		YES
    0x00ce48b4      A T 02350 	B1 = S1
    0x00ce4940      A   02360 	I3 = I
    0x00ce49e0      A   02370 	J3 = J
    0x00ce4a2c      A   02380 	REM********		END OF SCAN LOOP
    0x00ce4a8c      A T 02390     NEXT J
    0x00ce4ae8      A   02400 NEXT I
    0x00ce4b60      A   02410 REM********		COULD WE DO ANYTHING?
    0x00ce4c48      A   02420 IF B1 > 0 THEN 2510
    0x00ce4ca8      A   02430 REM********		NO
    0x00ce4dc0      A   02440 LET L = 18
    0x00ce4e18      A   02450 GOSUB 5340
    0x00ce4ee0      A   02460 PRINT "DAMN! HAVE TO FORFEIT MY MOVE!"
    0x00ce4fb0      A   02470 IF Z = 1 THEN 3370
    0x00ce508c      A   02480 Z = 1
    0x00ce50d8      A   02490 GO TO 2760
    0x00ce511c      A   02500 REM********		MAKE THE MOVE
    0x00ce51ec      A T 02510 Z = 0
    0x00ce52b0      A   02520 LET L=15
    0x00ce52fc      A   02530 GOSUB 5340
    0x00ce53c0      A   02540 PRINT "I WILL MOVE TO ";
    0x00ce5440      A   02550 PRINT I3;
    0x00ce5504      A   02560 PRINT " , ";
    0x00ce5590      A   02570 PRINT C$(J3)
    0x00ce561c      A   02580 I= I3
    0x00ce56a4      A   02590 J= J3
    0x00ce5768      A   02600 U= 1
    0x00ce57ac      A   02610 GOSUB 4799
    0x00ce58f8      A   02620 C1 = C1 + S1 + 1
    0x00ce59cc      A   02630 H1 = H1 - S1
    0x00ce5ad4      A   02640 N1 = N1 + 1
    0x00ce5b98      A   02650 LET L=16
    0x00ce5be4      A   02660 GOSUB 5340
    0x00ce5ca8      A   02670 PRINT " THAT GIVES ME : ";
    0x00ce5d34      A   02680 PRINT S1;
    0x00ce5e00      A   02690 PRINT " OF YOUR PIECES"
    0x00ce5e50      A   02700 REM********		PRINT OUT BOARD
    0x00ce5eb4      A   02710 GOSUB 5159
    0x00ce5f00      A   02720 REM********		TEST FOR END OF GAME
    0x00ce5fe8      A   02730 IF H1 = 0 THEN 3370
    0x00ce60dc      A   02740 IF N1 = 64 THEN 3370
    0x00ce6150      A   02750 REM********		HUMANS MOVE
    0x00ce61e4      A T 02760 T1 = H
    0x00ce6270      A   02770 T2 = C
    0x00ce6334      A   02780 LET L = 12
    0x00ce637c      A   02790 GOSUB 5340
    0x00ce6440      A T 02800 PRINT " YOUR MOVE";
    0x00ce64d8      A T 02810 INPUT I, X$
    0x00ce65a8      A   02820 IF I < 0 THEN 2810
    0x00ce6698      A   02830 IF I > 8 THEN 2810
    0x00ce678c      A   02840 IF I <> 0 THEN 2930
    0x00ce686c      A   02850 LET L = 18
    0x00ce68cc      A   02860 GOSUB 5340
    0x00ce6990      A   02870 PRINT "ARE YOU FORFEITING YOUR TURN Y OR N"
    0x00ce6a04      A   02880 INPUT X$
    0x00ce6ae0      A   02890 IF X$ <> "Y" THEN 2800
    0x00ce6bd0      A   02900 IF Z = 1 THEN 3370
    0x00ce6cac      A   02910 Z = 1
    0x00ce6cec      A   02920 GO TO 2010
    0x00ce6e1c      A T 02930 FOR J = 1 TO 8
    0x00ce6ee0      A   02940     IF C$(J) =X$ THEN 2980
    0x00ce6f48      A   02950 NEXT J
    0x00ce6fa8      A   02960 GO TO 2810
    0x00ce6ff0      A   02970 REM********		CHECK FOR BLANK
    0x00ce712c      A T 02980 IF A(I,J) = 0 THEN 3040
    0x00ce720c      A   02990 LET L = 18
    0x00ce7270      A   03000 GOSUB 5340
    0x00ce7338      A   03010 PRINT "SORRY, THAT SQUARE IS OCCUPIED, TRY AGAIN"
    0x00ce7394      A   03020 GO TO 2810
    0x00ce73e4      A   03030 REM********		CHECK FOR LEGAL NEIGHBOUR
    0x00ce743c      A T 03040 GOSUB 4639
    0x00ce7504      A   03050 IF F1 = 1 THEN 3110
    0x00ce75e4      A   03060 LET L = 18
    0x00ce7658      A   03070 GOSUB 5340
    0x00ce7744      A   03080 PRINT "SORRY, YOU ARE NOT NEXT TO ONE OF MY PIECES. TRY AGAIN.";
    0x00ce779c      A   03090 GO TO 2810
    0x00ce77e4      A   03100 REM********		CHECK IF LEGAL RUN
    0x00ce78b4      A T 03110 U = -1
    0x00ce78fc      A   03120 GOSUB 4799
    0x00ce79c4      A   03130 IF S1 > 0 THEN 3190
    0x00ce7aa4      A   03140 LET L = 18
    0x00ce7b08      A   03150 GOSUB 5340
    0x00ce7bd4      A   03160 PRINT "SORRY, THAT DOESN'T FLANK A ROW, TRY AGAIN"
    0x00ce7c3c      A   03170 GO TO 2810
    0x00ce7c94      A   03180 REM********		EVERYTHING LEGAL; MAKE HUMANS MOVE
    0x00ce7d64      A T 03190 Z = 0
    0x00ce7e28      A   03200 LET L = 13
    0x00ce7e74      A   03210 GOSUB 5340
    0x00ce7f38      A   03220 PRINT "THAT GIVES YOU";
    0x00ce7fc0      A   03230 PRINT S1;
    0x00ce0574      A   03240 PRINT " OF MY PIECES"
    0x00ce063c      A   03250 U = 1
    0x00ce0680      A   03260 GOSUB 4799
    0x00ce80cc      A   03270 H1 = H1 + S1 + 1
    0x00ce81a0      A   03280 C1 = C1 -S1
    0x00ce82bc      A   03290 N1 = N1 + 1
    0x00ce8308      A   03300 REM********		PRINT OUT BOARD
    0x00ce836c      A   03310 GOSUB 5159
    0x00ce83b8      A   03320 REM********		TEST FOR END OF GAME
    0x00ce84a0      A   03330 IF C1 = 0 THEN 3370
    0x00ce8594      A   03340 IF N1 = 64 THEN 3370
    0x00ce8604      A   03350 GO TO 2010
    0x00ce8650      A   03360 REM********		END OF GAME ; WRAPUP
    0x00ce8724      A T 03370 LET L = 18
    0x00ce8780      A   03380 GOSUB 5340
    0x00ce8840      A   03390 PRINT "FOR RESULTS ON GAME TYPE RETURN!!"
    0x00ce88b8      A   03400 INPUT X$
    0x00ce8a24      A   03410 PRINT CHR$(30),CHR$(26)
    0x00ce8ae8      A   03420 PRINT "YOU HAVE ";
    0x00ce8b78      A   03430 PRINT H1;
    0x00ce8c48      A   03440 PRINT " PIECES, AND I HAVE ";
    0x00ce8cd0      A   03450 PRINT C1;
    0x00ce8d90      A   03460 PRINT " PIECES--- "
    0x00ce8e28      A   03470 IF H1 = C1 THEN 3510
    0x00ce8ee4      A   03480 IF H1 > C1 THEN 3530
    0x00ce8fd0      A   03490 PRINT "SORRY, I WON THAT ONE."
    0x00ce901c      A   03500 GO TO 3540
    0x00ce90c8      A T 03510 PRINT " A TIE!!!!!"
    0x00ce9110      A   03520 GO TO 3720
    0x00ce91c0      A T 03530 PRINT "YOU WON!!!"
    0x00ce92a0      A T 03540 C1 = C1 - H1
    0x00ce936c      A   03550 IF C1 > 0 THEN 3570
    0x00ce941c      A   03560 C1 = -C1
    0x00ce9d94      A T 03570 C1 = (64 * C1)/ N1
    0x00ce9e64      A   03580 PRINT "THAT WAS A ";
    0x00ce9f34      A   03590 IF C1 < 11 THEN 3710
    0x00cea028      A   03600 IF C1 < 25 THEN 3690
    0x00cea11c      A   03610 IF C1 < 39 THEN 3670
    0x00cea210      A   03620 IF C1 < 53 THEN 3650
    0x00cea2f0      A   03630 PRINT " A PERFECT GAME!"
    0x00cea338      A   03640 GO TO 3720
    0x00cea3e0      A T 03650 PRINT "WALKAWAY!"
    0x00cea424      A   03660 GO TO 3720
    0x00cea4cc      A T 03670 PRINT "FIGHT!"
    0x00cea514      A   03680 GO TO 3720
    0x00cea5bc      A T 03690 PRINT "HOT GAME!"
    0x00cea604      A   03700 GO TO 3720
    0x00cea6a8      A T 03710 PRINT "SQUEAKER!"
    0x00cea700      A T 03720 PRINT
    0x00cea7d4      A   03730 PRINT"DO YOU WANT TO PLAY AGAIN";
    0x00cea848      A T 03740 INPUT X$
    0x00cea924      A   03750 IF X$ = "Y" THEN 1700
    0x00ceaa24      A   03760 IF X$ <> "N" THEN 3740
    0x00ceab08      A   03770 PRINT "THANKS FOR PLAYING."
    0x00ceab34      A   03780 STOP
    0x00cee1e8      A   04620 END
    0x00cf516c     B  G 04639 GOTO 4690 (Pseudo Goto)
    0x00ceab80     B    04640 REM********		
    0x00ceac18     B    04650 REM********		SUBROUTINE: TEST FOR PROPER NEIGHBOUR
    0x00ceac78     B    04660 REM********		ASSUMES:
    0x00ceacfc     B    04670 REM********		I,J LOCATES A BLANK SQUARE
    0x00cead9c     B    04680 REM********		YOU HOPE TO SEE AN ADJACENT  T2 (= -T1)
    0x00ceaf28     B  T 04690 FOR I1 =  -1 TO 1
    0x00ceb0b0     B    04700     FOR J1 = -1 TO 1
    0x00ceb224     B    04710 	IF  A(I+I1,J+J1) = T2 THEN 4780
    0x00ceb294     B    04720     NEXT J1
    0x00ceb2f4     B    04730 NEXT I1
    0x00ceb35c     B    04740 REM********		NO T2 FOUND
    0x00ceb428     B    04750 F1 = 0
    0x00cf51b4     B    04760 GOTO 4790 (Pseudo Goto)
    0x00ceb4ac     B    04770 REM********		SUCCESS
    0x00ceb578     B  T 04780 F1 = 1
    0x00ceb5a0     B  T 04790 RETURN
    0x00cf51fc    C   G 04799 GOTO 4890 (Pseudo Goto)
    0x00ceb624    C     04800 REM********		SUBROUTINE SCORE AND UPDATE
    0x00ceb684    C     04810 REM********		ASSUMES;
    0x00ceb728    C     04820 REM********		(I,J) IS A TENTATIVE PLACE FOR A PIECE T1.
    0x00ceb7cc    C     04830 REM********		WANT RUNS OF T2 = -T1, TERMINATED BY A T1.
    0x00ceb870    C     04840 REM********		IF U IS TRUE (1), MARK THOSE RUNS AS T1'S.
    0x00ceb910    C     04850 REM********		RETURN SUM OF ALL RUNS (T2'S ONLY) IN S1.
    0x00ceb9b8    C     04860 REM********		MAIN PROGRAM CONTAINS THE FOLLOWING ARRAYS:
    0x00ceba40    C     04870 REM********		I4:  0 -1 -1 -1  0  1  1  1
    0x00cebac8    C     04880 REM********		J4:  1  1  0 -1 -1 -1  0  1
    0x00cebb9c    C   T 04890 S1 = 0
    0x00cebcc4    C     04900 FOR K = 1 TO 8
    0x00cebdc8    C     04910     I5 = I4(K)
    0x00cebec8    C     04920     J5 = J4(K)
    0x00ce4000    C     04930     I6 = I + I5
    0x00ce40fc    C     04940     J6 = J + J5
    0x00ce421c    C     04950     S3 = 0
    0x00ce4300    C     04960     IF A(I6,J6) <> T2 THEN 5140
    0x00ce4378    C     04970     REM			LOOP THROUGH THE RUN
    0x00cec0b4    C   T 04980     S3 = S3 + 1
    0x00cec18c    C     04990     I6 = I6 + I5
    0x00cec274    C     05000     J6 = J6 + J5
    0x00cec358    C     05010     IF A (I6,J6) = T1 THEN 5040
    0x00cec4a4    C     05020     IF A(I6,J6) = 0 THEN 5140
    0x00cec4f0    C     05030     GO TO 4980
    0x00cec5cc    C   T 05040     S1 = S1 + S3
    0x00cec698    C     05050     IF U <> 1 THEN 5140
    0x00cec700    C     05060     REM			UPDATE BOARD
    0x00cec79c    C     05070     I6 = I
    0x00cec834    C     05080     J6 = J
    0x00cec968    C     05090     FOR K1 = 0 TO S3
    0x00ceca50    C     05100 	A(I6,J6) = T1
    0x00cecb24    C     05110 	I6 = I6 + I5
    0x00cecbf8    C     05120 	J6 = J6 + J5
    0x00cecc48    C     05130     NEXT K1
    0x00cecca4    C   T 05140 NEXT K
    0x00ceccd8    C     05150 RETURN
    0x00cf5244   D    G 05159 GOTO 5170 (Pseudo Goto)
    0x00cecd54   D      05160 REM********		SUBROUTINE TO PRINT BOARD
    0x00cece2c   D    T 05170 PRINT CHR$(30)
    0x00cecf00   D      05180 LET L = 18
    0x00cecfcc   D      05190 IF F9 = 1 GO TO 5220
    0x00ced024   D      05200 GOSUB 5420
    0x00ced0e8   D      05210 LET F9 = 1
    0x00ced1c0   D    T 05220 PRINT CHR$(30)
    0x00ced280   D      05230 PRINT "    A B C D E F G H"
    0x00ced3ac   D      05240 FOR I = 1 TO 8
    0x00ced434   D      05250     PRINT I;
    0x00ced560   D      05260     FOR J = 1 TO 8
    0x00ced630   D      05270 	PRINT " ";
    0x00ced7a0   D      05280 	PRINT D$(A(I,J)+1);
    0x00ced7f4   D      05290     NEXT J
    0x00ced83c   D      05300     PRINT
    0x00ced890   D      05310 NEXT I
    0x00ced8d4   D      05320 PRINT
    0x00ced900   D      05330 RETURN
    0x00ced968  E     G 05340 REM********		***	SPACE		***
    0x00ceda48  E       05350 PRINT CHR$(30)
    0x00cedb7c  E       05360 FOR I9 = 1 TO L
    0x00cedbc0  E       05370     PRINT
    0x00cedc14  E       05380 NEXT I9
    0x00cedcfc  E       05390 IF L <> 18 GO TO 5410
    0x00ceddd4  E       05400 F9 = 0
    0x00ceddfc  E     T 05410 RETURN
    0x00cede68 F      G 05420 REM********		***	BLANK OUT	***
    0x00cedebc F        05430 GOSUB 5340
    0x00cee048 F        05440 PRINT TAB(60);" "
    0x00cee18c F        05450 PRINT TAB(60);" "
    0x00cee1b8 F        05460 RETURN
 */

//---------------------------------------------------------------------------
// $Header: D:\\Repository\\D\\Dev\\BasicGames\\Translator\\Translated\\Othelo.cpp,v 1.6 2011-10-16 22:43:30-04 alan Exp alan $ 
//
// NOTE: This program has been automatically tranlated by b2cpp
//
// $Log: Othelo.cpp,v $
// Revision 1.6  2011-10-16 22:43:30-04  alan
// Updating the translation of the BASIC programs.
// 
// 
//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//---------------------------------------------------------------------------
// Global data area.
//---------------------------------------------------------------------------
char* data_01600s[]={"0","-1","-1","-1","0","1","1","1"};
char* data_01640s[]={"1","1","0","-1","-1","-1","0","1"};
char* data_01680s[]={"A","B","C","D","E","F","G","H"};
//---------------------------------------------------------------------------




typedef enum {TYPE_None,TYPE_Integer,TYPE_Float,TYPE_String}t_type;
typedef struct{
    int    LineNum;
    int    Size;
    char** SData;
}t_data;
t_data ProgramData[] = {
    { 1600,  8,data_01600s},
    { 1640,  8,data_01640s},
    { 1680,  8,data_01680s},
    {    0,  0,NULL       }
};

#include "intrinsics.h"


//---------------------------------------------------------------------------
// Global variable area.
//
// NOTE: Variable names are long to allow for easy editing.
//---------------------------------------------------------------------------
int   A_int_arr[10][10];// Comments?
int   B_int;        // Comments?
int   B1_int;       // Comments?
int   C_int;        // Comments?
char* C_str_arr[9]; // Comments?
int   C1_int;       // Comments?
char* D_str_arr[3]; // Comments?
int   F1_int;       // Comments?
int   F2_int;       // Comments?
int   F9_int;       // Comments?
int   H_int;        // Comments?
int   H1_int;       // Comments?
int   I_int;        // Comments?
int   I1_int;       // Comments?
int   I3_int;       // Comments?
int   I4_int_arr[9];// Comments?
int   I5_int;       // Comments?
int   I6_int;       // Comments?
int   I9_int;       // Comments?
int   J_int;        // Comments?
int   J1_int;       // Comments?
int   J3_int;       // Comments?
int   J4_int_arr[9];// Comments?
int   J5_int;       // Comments?
int   J6_int;       // Comments?
int   K_int;        // Comments?
int   K1_int;       // Comments?
int   L_int;        // Comments?
int   N1_int;       // Comments?
int   R_int;        // Comments?
int   S1_int;       // Comments?
int   S2_int;       // Comments?
int   S3_int;       // Comments?
int   T1_int;       // Comments?
int   T2_int;       // Comments?
int   U_int;        // Comments?
int   W_int;        // Comments?
char* X_str;        // Comments?
int   Z_int;        // Comments?
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
char* GLBpStr=NULL;
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Subroutine Prototypes.
//---------------------------------------------------------------------------
void Routine_04639();
void Routine_04799();
void Routine_05159();
void Routine_05340();
void Routine_05420();

//---------------------------------------------------------------------------
// Program Functions.
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// Program Subroutines.
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Routine B
//---------------------------------------------------------------------------

void Routine_04639(){
    // 04639 GOTO 4690 (Pseudo Goto)
    goto Lbl_04690;
    // 04640 REM********		
    //********		
    // 04650 REM********		SUBROUTINE: TEST FOR PROPER NEIGHBOUR
    //********		subroutine: test for proper neighbour
    // 04660 REM********		ASSUMES:
    //********		assumes:
    // 04670 REM********		I,J LOCATES A BLANK SQUARE
    //********		i,j locates a blank square
    // 04680 REM********		YOU HOPE TO SEE AN ADJACENT  T2 (= -T1)
    //********		you hope to see an adjacent  t2 (= -t1)

  Lbl_04690:
    // 04690 FOR I1 =  -1 TO 1
    for(I1_int=-1;I1_int<=1;I1_int++){
        // 04700     FOR J1 = -1 TO 1
        for(J1_int=-1;J1_int<=1;J1_int++){
            // 04710 	IF  A(I+I1,J+J1) = T2 THEN 4780
            if(A_int_arr[(int)I_int+I1_int][(int)J_int+J1_int]==T2_int) goto Lbl_04780;
            // 04720     NEXT J1
        }; // End-For(J1_int)
        // 04730 NEXT I1
    }; // End-For(I1_int)
    // 04740 REM********		NO T2 FOUND
    //********		no t2 found
    // 04750 F1 = 0
    F1_int = 0;
    // 04760 GOTO 4790 (Pseudo Goto)
    goto Lbl_04790;
    // 04770 REM********		SUCCESS
    //********		success

  Lbl_04780:
    // 04780 F1 = 1
    F1_int = 1;

  Lbl_04790:
    // 04790 RETURN
    return;
};


//---------------------------------------------------------------------------
// Routine C
//---------------------------------------------------------------------------

void Routine_04799(){
    // 04799 GOTO 4890 (Pseudo Goto)
    goto Lbl_04890;
    // 04800 REM********		SUBROUTINE SCORE AND UPDATE
    //********		subroutine score and update
    // 04810 REM********		ASSUMES;
    //********		assumes;
    // 04820 REM********		(I,J) IS A TENTATIVE PLACE FOR A PIECE T1.
    //********		(i,j) is a tentative place for a piece t1.
    // 04830 REM********		WANT RUNS OF T2 = -T1, TERMINATED BY A T1.
    //********		want runs of t2 = -t1, terminated by a t1.
    // 04840 REM********		IF U IS TRUE (1), MARK THOSE RUNS AS T1'S.
    //********		if u is true (1), mark those runs as t1's.
    // 04850 REM********		RETURN SUM OF ALL RUNS (T2'S ONLY) IN S1.
    //********		return sum of all runs (t2's only) in s1.
    // 04860 REM********		MAIN PROGRAM CONTAINS THE FOLLOWING ARRAYS:
    //********		main program contains the following arrays:
    // 04870 REM********		I4:  0 -1 -1 -1  0  1  1  1
    //********		i4:  0 -1 -1 -1  0  1  1  1
    // 04880 REM********		J4:  1  1  0 -1 -1 -1  0  1
    //********		j4:  1  1  0 -1 -1 -1  0  1

  Lbl_04890:
    // 04890 S1 = 0
    S1_int = 0;
    // 04900 FOR K = 1 TO 8
    for(K_int=1;K_int<=8;K_int++){
        // 04910     I5 = I4(K)
        I5_int = I4_int_arr[(int)K_int];
        // 04920     J5 = J4(K)
        J5_int = J4_int_arr[(int)K_int];
        // 04930     I6 = I + I5
        I6_int = I_int+I5_int;
        // 04940     J6 = J + J5
        J6_int = J_int+J5_int;
        // 04950     S3 = 0
        S3_int = 0;
        // 04960     IF A(I6,J6) <> T2 THEN 5140
        if(A_int_arr[(int)I6_int][(int)J6_int]!=T2_int) goto Lbl_05140;
        // 04970     REM			LOOP THROUGH THE RUN
        //			loop through the run

  Lbl_04980:
        // 04980     S3 = S3 + 1
        S3_int = S3_int+1;
        // 04990     I6 = I6 + I5
        I6_int = I6_int+I5_int;
        // 05000     J6 = J6 + J5
        J6_int = J6_int+J5_int;
        // 05010     IF A (I6,J6) = T1 THEN 5040
        if(A_int_arr[(int)I6_int][(int)J6_int]==T1_int) goto Lbl_05040;
        // 05020     IF A(I6,J6) = 0 THEN 5140
        if(A_int_arr[(int)I6_int][(int)J6_int]==0) goto Lbl_05140;
        // 05030     GO TO 4980
        goto Lbl_04980;

  Lbl_05040:
        // 05040     S1 = S1 + S3
        S1_int = S1_int+S3_int;
        // 05050     IF U <> 1 THEN 5140
        if(U_int!=1) goto Lbl_05140;
        // 05060     REM			UPDATE BOARD
        //			update board
        // 05070     I6 = I
        I6_int = I_int;
        // 05080     J6 = J
        J6_int = J_int;
        // 05090     FOR K1 = 0 TO S3
        for(K1_int=0;K1_int<=S3_int;K1_int++){
            // 05100 	A(I6,J6) = T1
            A_int_arr[(int)I6_int][(int)J6_int] = T1_int;
            // 05110 	I6 = I6 + I5
            I6_int = I6_int+I5_int;
            // 05120 	J6 = J6 + J5
            J6_int = J6_int+J5_int;
            // 05130     NEXT K1
        }; // End-For(K1_int)

  Lbl_05140:
        // 05140 NEXT K
    }; // End-For(K_int)
    // 05150 RETURN
    return;
};


//---------------------------------------------------------------------------
// Routine D
//---------------------------------------------------------------------------

void Routine_05159(){
    // 05159 GOTO 5170 (Pseudo Goto)
    goto Lbl_05170;
    // 05160 REM********		SUBROUTINE TO PRINT BOARD
    //********		subroutine to print board

  Lbl_05170:
    // 05170 PRINT CHR$(30)
    MyFpf(stdout,"%s\n",CHR_str(30));
    // 05180 LET L = 18
    L_int = 18;
    // 05190 IF F9 = 1 GO TO 5220
    if(F9_int==1) goto Lbl_05220;
    // 05200 GOSUB 5420
    Routine_05420();
    // 05210 LET F9 = 1
    F9_int = 1;

  Lbl_05220:
    // 05220 PRINT CHR$(30)
    MyFpf(stdout,"%s\n",CHR_str(30));
    // 05230 PRINT "    A B C D E F G H"
    MyFpf(stdout,"    a b c d e f g h\n");
    // 05240 FOR I = 1 TO 8
    for(I_int=1;I_int<=8;I_int++){
        // 05250     PRINT I;
        MyFpf(stdout,"%d",I_int);
        // 05260     FOR J = 1 TO 8
        for(J_int=1;J_int<=8;J_int++){
            // 05270 	PRINT " ";
            MyFpf(stdout," ");
            // 05280 	PRINT D$(A(I,J)+1);
            MyFpf(stdout,"%s",D_str_arr[(int)A_int_arr[(int)I_int][(int)J_int]+1]);
            // 05290     NEXT J
        }; // End-For(J_int)
        // 05300     PRINT
        MyFpf(stdout,"\n");
        // 05310 NEXT I
    }; // End-For(I_int)
    // 05320 PRINT
    MyFpf(stdout,"\n");
    // 05330 RETURN
    return;
};


//---------------------------------------------------------------------------
// Routine E
//---------------------------------------------------------------------------

void Routine_05340(){
    // 05340 REM********		***	SPACE		***
    //********		***	space		***
    // 05350 PRINT CHR$(30)
    MyFpf(stdout,"%s\n",CHR_str(30));
    // 05360 FOR I9 = 1 TO L
    for(I9_int=1;I9_int<=L_int;I9_int++){
        // 05370     PRINT
        MyFpf(stdout,"\n");
        // 05380 NEXT I9
    }; // End-For(I9_int)
    // 05390 IF L <> 18 GO TO 5410
    if(L_int!=18) goto Lbl_05410;
    // 05400 F9 = 0
    F9_int = 0;

  Lbl_05410:
    // 05410 RETURN
    return;
};


//---------------------------------------------------------------------------
// Routine F
//---------------------------------------------------------------------------

void Routine_05420(){
    // 05420 REM********		***	BLANK OUT	***
    //********		***	blank out	***
    // 05430 GOSUB 5340
    Routine_05340();
    // 05440 PRINT TAB(60);" "
    MyFpf(stdout,"%s \n",TAB(60));
    // 05450 PRINT TAB(60);" "
    MyFpf(stdout,"%s \n",TAB(60));
    // 05460 RETURN
    return;
};

//---------------------------------------------------------------------------
// Main Program.
//---------------------------------------------------------------------------
#pragma argsused
void main(int argc,char *argv[])
{
    // 01000 REM********		OTHELLO          BYTE VOL. 2, NUMBER 10 (OCT. 1977)
    //********		othello          byte vol. 2, number 10 (oct. 1977)
    // 01010 REM********		PLAYS THE GAME OTHELLO WITH TWO STRATEGIES
    //********		plays the game othello with two strategies
    // 01020 REM********		1. TAKE THE MAX. NUMBER OF PIECES
    //********		1. take the max. number of pieces
    // 01030 REM********		2. ADD A BONUS FOR OUTSIDE POSITION
    //********		2. add a bonus for outside position
    // 01040 REM********		BOARD IS THE ARRAY A, BOUNDED BY 0'S (BLANKS)
    //********		board is the array a, bounded by 0's (blanks)
    // 01050 REM********		A = 0 FOR EMPTY SQUARE
    //********		a = 0 for empty square
    // 01060 REM********		A = B FOR BLACK SQUARE
    //********		a = b for black square
    // 01070 REM********		A = W FOR WHITE SQUARE
    //********		a = w for white square
    // 01080 REM********		I AND J ARE ALWAYS USED FOR ROW/COLUMN INDICES
    //********		i and j are always used for row/column indices
    // 01090 REM********		I1 AND J4 STORE INCREMENTS TO THE 8 NEIGHBOURS
    //********		i1 and j4 store increments to the 8 neighbours
    // 01100 REM********		C$ AND D$ STORE CHARACTERS A-H,X,...,O FOR OUTPUT
    //********		c$ and d$ store characters a-h,x,...,o for output
    // 01110 DIM A(9,9),I4(8),J4(8),C$(8),D$(2)
    // 01120 REM********		
    //********		
    // 01130 PRINT "GREETINGS FROM OTHELLO!"
    MyFpf(stdout,"greetings from othello!\n");
    // 01140 PRINT "DO YOU WANT INSTRUCTIONS (Y OR N)";
    MyFpf(stdout,"do you want instructions (y or n)");

  Lbl_01150:
    // 01150 INPUT X$
    // Start of Basic INPUT statement 01150
    printf(" ? ");
    char inpbuf_01150[100];
    if(fgets(inpbuf_01150,100,stdin)==NULL){
        fprintf(stderr,"ERROR: End of file on input.\n");
        exit(2);
    }else{
        // This may cause problems if BASIC programmer expected
        // input strings to be copied instead of just pointing
        // to the input buffer (ie. strings can be over written).
        char *ps_01150=strtok(inpbuf_01150," ,\t\n");
        if(ps_01150==NULL){
            X_str = "";
        }else{
            X_str = ps_01150;
        };
    }; // End of Basic INPUT statement 01150
    // 01160 IF X$ = "N" THEN 1380
    if(strcmp(X_str,"n")==0) goto Lbl_01380;
    // 01170 IF X$ <> "Y" THEN 1150
    if(strcmp(X_str,"y")!=0) goto Lbl_01150;
    // 01180 PRINT
    MyFpf(stdout,"\n");
    // 01190 PRINT "OTHELLO IS PLAYED ON AN 8X8 CHECKER BOARD"
    MyFpf(stdout,"othello is played on an 8x8 checker board\n");
    // 01200 PRINT "ROWS ARE NUMBERED FROM 1 TO 8 AND COLUMNS FROM A TO H"
    MyFpf(stdout,"rows are numbered from 1 to 8 and columns from a to h\n");
    // 01210 PRINT" THE INITIAL CONFIGURATION IS ALL BLANK EXCEPT FOR"
    MyFpf(stdout," the initial configuration is all blank except for\n");
    // 01220 PRINT "THE CENTER FOUR SQUARES, WHICH FORM THE PATTERN:"
    MyFpf(stdout,"the center four squares, which form the pattern:\n");
    // 01230 PRINT "               O X"
    MyFpf(stdout,"               o x\n");
    // 01240 PRINT "               X O"
    MyFpf(stdout,"               x o\n");
    // 01250 PRINT
    MyFpf(stdout,"\n");
    // 01260 PRINT "TRY TO PLACE YOUR PIECE SO THAT IT WILL 'OUTFLANK' MINE"
    MyFpf(stdout,"try to place your piece so that it will 'outflank' mine\n");
    // 01270 PRINT "THEREBY CREATING A HORIZONTAL, VERTICAL, OR DIAGONAL "
    MyFpf(stdout,"thereby creating a horizontal, vertical, or diagonal \n");
    // 01280 PRINT "RUN OF MY PIECES BOUNDED AT EACH END BY AT LEAST ONE "
    MyFpf(stdout,"run of my pieces bounded at each end by at least one \n");
    // 01290 PRINT "OF YOURS.  THIS WILL 'FLIP' MY PIECES, TURNING THEM INTO"
    MyFpf(stdout,"of yours.  this will 'flip' my pieces, turning them into\n");
    // 01300 PRINT "YOURS."
    MyFpf(stdout,"yours.\n");
    // 01310 PRINT"     NOTE: YOU MUST CAPTURE AT LEAST ONE OF MY PIECES"
    MyFpf(stdout,"     note: you must capture at least one of my pieces\n");
    // 01320 PRINT "IN THIS WAY IF IT IS AT ALL POSSIBLE.  IF IT IS NOT"
    MyFpf(stdout,"in this way if it is at all possible.  if it is not\n");
    // 01330 PRINT "POSSIBLE, YOU FORFEIT YOUR TURN BY ENTERING"
    MyFpf(stdout,"possible, you forfeit your turn by entering\n");
    // 01340 PRINT "     0,0   FOR YOUR ROW,COLUMN MOVE"
    MyFpf(stdout,"     0,0   for your row,column move\n");
    // 01350 PRINT " GOOD LUCK!"
    MyFpf(stdout," good luck!\n");
    // 01360 PRINT
    MyFpf(stdout,"\n");
    // 01370 REM********		
    //********		

  Lbl_01380:
    // 01380 PRINT "SHOULD I WAIT BEFORE MAKING MY MOVES (Y OR N)";
    MyFpf(stdout,"should i wait before making my moves (y or n)");
    // 01390 F2 = 0
    F2_int = 0;
    // 01400 F9 = 1
    F9_int = 1;

  Lbl_01410:
    // 01410 INPUT X$
    // Start of Basic INPUT statement 01410
    printf(" ? ");
    char inpbuf_01410[100];
    if(fgets(inpbuf_01410,100,stdin)==NULL){
        fprintf(stderr,"ERROR: End of file on input.\n");
        exit(2);
    }else{
        // This may cause problems if BASIC programmer expected
        // input strings to be copied instead of just pointing
        // to the input buffer (ie. strings can be over written).
        char *ps_01410=strtok(inpbuf_01410," ,\t\n");
        if(ps_01410==NULL){
            X_str = "";
        }else{
            X_str = ps_01410;
        };
    }; // End of Basic INPUT statement 01410
    // 01420 IF X$ = "N" THEN 1460
    if(strcmp(X_str,"n")==0) goto Lbl_01460;
    // 01430 IF X$ <> "Y" THEN  1410
    if(strcmp(X_str,"y")!=0) goto Lbl_01410;
    // 01440 F2 = 1
    F2_int = 1;
    // 01450         PRINT "OK.  TYPING ANY CHARACTER WILL LET ME GO"
    MyFpf(stdout,"ok.  typing any character will let me go\n");

  Lbl_01460:
    // 01460 PRINT "SHOULD I PLAY MY BEST STRATEGY (Y OR N)";
    MyFpf(stdout,"should i play my best strategy (y or n)");
    // 01470 S2 = 0
    S2_int = 0;

  Lbl_01480:
    // 01480 INPUT X$
    // Start of Basic INPUT statement 01480
    printf(" ? ");
    char inpbuf_01480[100];
    if(fgets(inpbuf_01480,100,stdin)==NULL){
        fprintf(stderr,"ERROR: End of file on input.\n");
        exit(2);
    }else{
        // This may cause problems if BASIC programmer expected
        // input strings to be copied instead of just pointing
        // to the input buffer (ie. strings can be over written).
        char *ps_01480=strtok(inpbuf_01480," ,\t\n");
        if(ps_01480==NULL){
            X_str = "";
        }else{
            X_str = ps_01480;
        };
    }; // End of Basic INPUT statement 01480
    // 01490 IF X$ = "N" THEN 1520
    if(strcmp(X_str,"n")==0) goto Lbl_01520;
    // 01500 IF X$ <> "Y" THEN 1480
    if(strcmp(X_str,"y")!=0) goto Lbl_01480;
    // 01510 S2 = 2
    S2_int = 2;

  Lbl_01520:
    // 01520 B = -1
    B_int = -1;
    // 01530 W = +1
    W_int = 1;
    // 01540 D$(B +1) ="X"
    GLBpStr="x";
    D_str_arr[(int)B_int+1] = (GLBpStr==GLB_StrCatBuf)?strdup(GLBpStr):GLBpStr;
    // 01550 D$(0 +1) = "."
    GLBpStr=".";
    D_str_arr[(int)0+1] = (GLBpStr==GLB_StrCatBuf)?strdup(GLBpStr):GLBpStr;
    // 01560 D$(W + 1) ="O"
    GLBpStr="o";
    D_str_arr[(int)W_int+1] = (GLBpStr==GLB_StrCatBuf)?strdup(GLBpStr):GLBpStr;
    // 01570 FOR K = 1 TO 8
    for(K_int=1;K_int<=8;K_int++){
        // 01580     READ I4(K)
        I4_int_arr[(int)K_int] = Get_Data_Int();
        // 01590 NEXT K
    }; // End-For(K_int)
    // 01600 DATA 0,-1,-1,-1,0,1,1,1
    // 01610 FOR K=1 TO 8
    for(K_int=1;K_int<=8;K_int++){
        // 01620     READ J4(K)
        J4_int_arr[(int)K_int] = Get_Data_Int();
        // 01630 NEXT K
    }; // End-For(K_int)
    // 01640 DATA 1,1,0,-1,-1,-1,0,1
    // 01650 FOR K = 1 TO 8
    for(K_int=1;K_int<=8;K_int++){
        // 01660     READ C$(K)
        C_str_arr[(int)K_int] = Get_Data_String();
        // 01670 NEXT K
    }; // End-For(K_int)
    // 01680 DATA A,B,C,D,E,F,G,H
    // 01690 REM********		SET UP A NEW GAME
    //********		set up a new game

  Lbl_01700:
    // 01700 FOR I = 0 TO 9
    for(I_int=0;I_int<=9;I_int++){
        // 01710     FOR J = 0 TO 9
        for(J_int=0;J_int<=9;J_int++){
            // 01720 	A(I,J)=0
            A_int_arr[(int)I_int][(int)J_int] = 0;
            // 01730     NEXT J
        }; // End-For(J_int)
        // 01740 NEXT I
    }; // End-For(I_int)
    // 01750 A(4,4) = W
    A_int_arr[(int)4][(int)4] = W_int;
    // 01760 A(5,5) = W
    A_int_arr[(int)5][(int)5] = W_int;
    // 01770 A(4,5) = B
    A_int_arr[(int)4][(int)5] = B_int;
    // 01780 A(5,4) = B
    A_int_arr[(int)5][(int)4] = B_int;
    // 01790 C1 = 2
    C1_int = 2;
    // 01800 H1 = 2
    H1_int = 2;
    // 01810 N1 = 4
    N1_int = 4;
    // 01820 Z =0
    Z_int = 0;
    // 01830 REM********		HUMAN'S CHOICES
    //********		human's choices
    // 01840 PRINT "DO YOU WANT TO HAVE X OR O";
    MyFpf(stdout,"do you want to have x or o");
    // 01850 C = W
    C_int = W_int;
    // 01860 H = B
    H_int = B_int;

  Lbl_01870:
    // 01870 INPUT X$
    // Start of Basic INPUT statement 01870
    printf(" ? ");
    char inpbuf_01870[100];
    if(fgets(inpbuf_01870,100,stdin)==NULL){
        fprintf(stderr,"ERROR: End of file on input.\n");
        exit(2);
    }else{
        // This may cause problems if BASIC programmer expected
        // input strings to be copied instead of just pointing
        // to the input buffer (ie. strings can be over written).
        char *ps_01870=strtok(inpbuf_01870," ,\t\n");
        if(ps_01870==NULL){
            X_str = "";
        }else{
            X_str = ps_01870;
        };
    }; // End of Basic INPUT statement 01870
    // 01880 IF X$ = "X" THEN 1920
    if(strcmp(X_str,"x")==0) goto Lbl_01920;
    // 01890 IF X$ <> "O" THEN 1870
    if(strcmp(X_str,"o")!=0) goto Lbl_01870;
    // 01900 C = B
    C_int = B_int;
    // 01910 H = W
    H_int = W_int;

  Lbl_01920:
    // 01920 PRINT "DO YOU WANT TO GO FIRST (Y OR N)";
    MyFpf(stdout,"do you want to go first (y or n)");

  Lbl_01930:
    // 01930 INPUT X$
    // Start of Basic INPUT statement 01930
    printf(" ? ");
    char inpbuf_01930[100];
    if(fgets(inpbuf_01930,100,stdin)==NULL){
        fprintf(stderr,"ERROR: End of file on input.\n");
        exit(2);
    }else{
        // This may cause problems if BASIC programmer expected
        // input strings to be copied instead of just pointing
        // to the input buffer (ie. strings can be over written).
        char *ps_01930=strtok(inpbuf_01930," ,\t\n");
        if(ps_01930==NULL){
            X_str = "";
        }else{
            X_str = ps_01930;
        };
    }; // End of Basic INPUT statement 01930
    // 01940 PRINT CHR$(26)
    MyFpf(stdout,"%s\n",CHR_str(26));
    // 01950 IF X$ = "N" THEN 2030
    if(strcmp(X_str,"n")==0) goto Lbl_02030;
    // 01960 IF X$ <> "Y" THEN 1930
    if(strcmp(X_str,"y")!=0) goto Lbl_01930;
    // 01970 REM********		PRINT INITIAL BOARD
    //********		print initial board
    // 01980 GOSUB 5159
    Routine_05159();
    // 01990 GO TO 2760
    goto Lbl_02760;
    // 02000 REM********		COMPUTER'S MOVE
    //********		computer's move

  Lbl_02010:
    // 02010 IF F2 = 0 THEN 2030
    if(F2_int==0) goto Lbl_02030;
    // 02020 INPUT X$
    // Start of Basic INPUT statement 02020
    printf(" ? ");
    char inpbuf_02020[100];
    if(fgets(inpbuf_02020,100,stdin)==NULL){
        fprintf(stderr,"ERROR: End of file on input.\n");
        exit(2);
    }else{
        // This may cause problems if BASIC programmer expected
        // input strings to be copied instead of just pointing
        // to the input buffer (ie. strings can be over written).
        char *ps_02020=strtok(inpbuf_02020," ,\t\n");
        if(ps_02020==NULL){
            X_str = "";
        }else{
            X_str = ps_02020;
        };
    }; // End of Basic INPUT statement 02020

  Lbl_02030:
    // 02030 B1 = -1
    B1_int = -1;
    // 02040 I3 = J3 = 0
    J3_int = I3_int = 0;
    // 02050 T1 = C
    T1_int = C_int;
    // 02060 T2 = H
    T2_int = H_int;
    // 02070 REM********		SCAN FOR BLANK SQUARE
    //********		scan for blank square
    // 02080 FOR I = 1 TO 8
    for(I_int=1;I_int<=8;I_int++){
        // 02090     FOR J = 1 TO 8
        for(J_int=1;J_int<=8;J_int++){
            // 02100 	IF A(I,J) <> 0 THEN 2390
            if(A_int_arr[(int)I_int][(int)J_int]!=0) goto Lbl_02390;
            // 02110 	REM********		FOUND A BLANK SQUARE
            //********		found a blank square
            // 02120 	REM********		DOES IT HAVE AN OPPONENT AS A NEIGHBOUR
            //********		does it have an opponent as a neighbour
            // 02130 	GOSUB 4639
            Routine_04639();
            // 02140 	IF F1 = 0 THEN 2390
            if(F1_int==0) goto Lbl_02390;
            // 02150 	REM********		FOUND OPPONENT AS NEIGHBOUR
            //********		found opponent as neighbour
            // 02160 	REM********		HOW MANY OF HIS PIECES CAN WE FLIP?
            //********		how many of his pieces can we flip?
            // 02170 	REM********		DON'T DO IT NOW
            //********		don't do it now
            // 02180 	U = -1
            U_int = -1;
            // 02190 	GOSUB 4799
            Routine_04799();
            // 02200 	REM********		EXTRA POINTS FOR BOUNDARY POSITION
            //********		extra points for boundary position
            // 02210 	IF S1 = 0 THEN 2390
            if(S1_int==0) goto Lbl_02390;
            // 02220 	IF (I-1) * (I-8) <> 0 THEN 2240
            if((I_int-1)*(I_int-8)!=0) goto Lbl_02240;
            // 02230 	S1 = S1 + S2
            S1_int = S1_int+S2_int;

  Lbl_02240:
            // 02240 	IF (J-1) * (J-8) <> 0 THEN 2270
            if((J_int-1)*(J_int-8)!=0) goto Lbl_02270;
            // 02250 	S1 = S1 +S2
            S1_int = S1_int+S2_int;
            // 02260 	REM********		IS THIS BETTER THAN THE BEST FOUND SO FAR
            //********		is this better than the best found so far

  Lbl_02270:
            // 02270 	IF S1 < B1 THEN 2390
            if(S1_int<B1_int) goto Lbl_02390;
            // 02280 	IF S1 > B1 THEN 2350
            if(S1_int>B1_int) goto Lbl_02350;
            // 02290 	REM********		A TIE; RANDOM DECISION
            //********		a tie; random decision
            // 02300 	REM********		THE NEXT TWO EXECUTABLE STATEMENTS ARE FOR
            //********		the next two executable statements are for
            // 02310 	REM********		BASIC WITH RANDOM NUMBERS
            //********		basic with random numbers
            // 02320 	R = RND(1)
            R_int = RND(1);
            // 02330 	IF R > .5 THEN 2390
            if(R_int>0.5) goto Lbl_02390;
            // 02340 	REM********		YES
            //********		yes

  Lbl_02350:
            // 02350 	B1 = S1
            B1_int = S1_int;
            // 02360 	I3 = I
            I3_int = I_int;
            // 02370 	J3 = J
            J3_int = J_int;
            // 02380 	REM********		END OF SCAN LOOP
            //********		end of scan loop

  Lbl_02390:
            // 02390     NEXT J
        }; // End-For(J_int)
        // 02400 NEXT I
    }; // End-For(I_int)
    // 02410 REM********		COULD WE DO ANYTHING?
    //********		could we do anything?
    // 02420 IF B1 > 0 THEN 2510
    if(B1_int>0) goto Lbl_02510;
    // 02430 REM********		NO
    //********		no
    // 02440 LET L = 18
    L_int = 18;
    // 02450 GOSUB 5340
    Routine_05340();
    // 02460 PRINT "DAMN! HAVE TO FORFEIT MY MOVE!"
    MyFpf(stdout,"damn! have to forfeit my move!\n");
    // 02470 IF Z = 1 THEN 3370
    if(Z_int==1) goto Lbl_03370;
    // 02480 Z = 1
    Z_int = 1;
    // 02490 GO TO 2760
    goto Lbl_02760;
    // 02500 REM********		MAKE THE MOVE
    //********		make the move

  Lbl_02510:
    // 02510 Z = 0
    Z_int = 0;
    // 02520 LET L=15
    L_int = 15;
    // 02530 GOSUB 5340
    Routine_05340();
    // 02540 PRINT "I WILL MOVE TO ";
    MyFpf(stdout,"i will move to ");
    // 02550 PRINT I3;
    MyFpf(stdout,"%d",I3_int);
    // 02560 PRINT " , ";
    MyFpf(stdout," , ");
    // 02570 PRINT C$(J3)
    MyFpf(stdout,"%s\n",C_str_arr[(int)J3_int]);
    // 02580 I= I3
    I_int = I3_int;
    // 02590 J= J3
    J_int = J3_int;
    // 02600 U= 1
    U_int = 1;
    // 02610 GOSUB 4799
    Routine_04799();
    // 02620 C1 = C1 + S1 + 1
    C1_int = C1_int+S1_int+1;
    // 02630 H1 = H1 - S1
    H1_int = H1_int-S1_int;
    // 02640 N1 = N1 + 1
    N1_int = N1_int+1;
    // 02650 LET L=16
    L_int = 16;
    // 02660 GOSUB 5340
    Routine_05340();
    // 02670 PRINT " THAT GIVES ME : ";
    MyFpf(stdout," that gives me : ");
    // 02680 PRINT S1;
    MyFpf(stdout,"%d",S1_int);
    // 02690 PRINT " OF YOUR PIECES"
    MyFpf(stdout," of your pieces\n");
    // 02700 REM********		PRINT OUT BOARD
    //********		print out board
    // 02710 GOSUB 5159
    Routine_05159();
    // 02720 REM********		TEST FOR END OF GAME
    //********		test for end of game
    // 02730 IF H1 = 0 THEN 3370
    if(H1_int==0) goto Lbl_03370;
    // 02740 IF N1 = 64 THEN 3370
    if(N1_int==64) goto Lbl_03370;
    // 02750 REM********		HUMANS MOVE
    //********		humans move

  Lbl_02760:
    // 02760 T1 = H
    T1_int = H_int;
    // 02770 T2 = C
    T2_int = C_int;
    // 02780 LET L = 12
    L_int = 12;
    // 02790 GOSUB 5340
    Routine_05340();

  Lbl_02800:
    // 02800 PRINT " YOUR MOVE";
    MyFpf(stdout," your move");

  Lbl_02810:
    // 02810 INPUT I, X$
    // Start of Basic INPUT statement 02810
    printf(" ? ");
    char inpbuf_02810[100];
    if(fgets(inpbuf_02810,100,stdin)==NULL){
        fprintf(stderr,"ERROR: End of file on input.\n");
        exit(2);
    }else{
        // This may cause problems if BASIC programmer expected
        // input strings to be copied instead of just pointing
        // to the input buffer (ie. strings can be over written).
        char *ps_02810=strtok(inpbuf_02810," ,\t\n");
        if(ps_02810==NULL){
            I_int = 0;
        }else{
            I_int = atoi(ps_02810);
        };
        ps_02810=strtok(NULL," ,\t\n");
        if(ps_02810==NULL){
            X_str = "";
        }else{
            X_str = ps_02810;
        };
    }; // End of Basic INPUT statement 02810
    // 02820 IF I < 0 THEN 2810
    if(I_int<0) goto Lbl_02810;
    // 02830 IF I > 8 THEN 2810
    if(I_int>8) goto Lbl_02810;
    // 02840 IF I <> 0 THEN 2930
    if(I_int!=0) goto Lbl_02930;
    // 02850 LET L = 18
    L_int = 18;
    // 02860 GOSUB 5340
    Routine_05340();
    // 02870 PRINT "ARE YOU FORFEITING YOUR TURN Y OR N"
    MyFpf(stdout,"are you forfeiting your turn y or n\n");
    // 02880 INPUT X$
    // Start of Basic INPUT statement 02880
    printf(" ? ");
    char inpbuf_02880[100];
    if(fgets(inpbuf_02880,100,stdin)==NULL){
        fprintf(stderr,"ERROR: End of file on input.\n");
        exit(2);
    }else{
        // This may cause problems if BASIC programmer expected
        // input strings to be copied instead of just pointing
        // to the input buffer (ie. strings can be over written).
        char *ps_02880=strtok(inpbuf_02880," ,\t\n");
        if(ps_02880==NULL){
            X_str = "";
        }else{
            X_str = ps_02880;
        };
    }; // End of Basic INPUT statement 02880
    // 02890 IF X$ <> "Y" THEN 2800
    if(strcmp(X_str,"y")!=0) goto Lbl_02800;
    // 02900 IF Z = 1 THEN 3370
    if(Z_int==1) goto Lbl_03370;
    // 02910 Z = 1
    Z_int = 1;
    // 02920 GO TO 2010
    goto Lbl_02010;

  Lbl_02930:
    // 02930 FOR J = 1 TO 8
    for(J_int=1;J_int<=8;J_int++){
        // 02940     IF C$(J) =X$ THEN 2980
        if(strcmp(C_str_arr[(int)J_int],X_str)==0) goto Lbl_02980;
        // 02950 NEXT J
    }; // End-For(J_int)
    // 02960 GO TO 2810
    goto Lbl_02810;
    // 02970 REM********		CHECK FOR BLANK
    //********		check for blank

  Lbl_02980:
    // 02980 IF A(I,J) = 0 THEN 3040
    if(A_int_arr[(int)I_int][(int)J_int]==0) goto Lbl_03040;
    // 02990 LET L = 18
    L_int = 18;
    // 03000 GOSUB 5340
    Routine_05340();
    // 03010 PRINT "SORRY, THAT SQUARE IS OCCUPIED, TRY AGAIN"
    MyFpf(stdout,"sorry, that square is occupied, try again\n");
    // 03020 GO TO 2810
    goto Lbl_02810;
    // 03030 REM********		CHECK FOR LEGAL NEIGHBOUR
    //********		check for legal neighbour

  Lbl_03040:
    // 03040 GOSUB 4639
    Routine_04639();
    // 03050 IF F1 = 1 THEN 3110
    if(F1_int==1) goto Lbl_03110;
    // 03060 LET L = 18
    L_int = 18;
    // 03070 GOSUB 5340
    Routine_05340();
    // 03080 PRINT "SORRY, YOU ARE NOT NEXT TO ONE OF MY PIECES. TRY AGAIN.";
    MyFpf(stdout,"sorry, you are not next to one of my pieces. try again.");
    // 03090 GO TO 2810
    goto Lbl_02810;
    // 03100 REM********		CHECK IF LEGAL RUN
    //********		check if legal run

  Lbl_03110:
    // 03110 U = -1
    U_int = -1;
    // 03120 GOSUB 4799
    Routine_04799();
    // 03130 IF S1 > 0 THEN 3190
    if(S1_int>0) goto Lbl_03190;
    // 03140 LET L = 18
    L_int = 18;
    // 03150 GOSUB 5340
    Routine_05340();
    // 03160 PRINT "SORRY, THAT DOESN'T FLANK A ROW, TRY AGAIN"
    MyFpf(stdout,"sorry, that doesn't flank a row, try again\n");
    // 03170 GO TO 2810
    goto Lbl_02810;
    // 03180 REM********		EVERYTHING LEGAL; MAKE HUMANS MOVE
    //********		everything legal; make humans move

  Lbl_03190:
    // 03190 Z = 0
    Z_int = 0;
    // 03200 LET L = 13
    L_int = 13;
    // 03210 GOSUB 5340
    Routine_05340();
    // 03220 PRINT "THAT GIVES YOU";
    MyFpf(stdout,"that gives you");
    // 03230 PRINT S1;
    MyFpf(stdout,"%d",S1_int);
    // 03240 PRINT " OF MY PIECES"
    MyFpf(stdout," of my pieces\n");
    // 03250 U = 1
    U_int = 1;
    // 03260 GOSUB 4799
    Routine_04799();
    // 03270 H1 = H1 + S1 + 1
    H1_int = H1_int+S1_int+1;
    // 03280 C1 = C1 -S1
    C1_int = C1_int-S1_int;
    // 03290 N1 = N1 + 1
    N1_int = N1_int+1;
    // 03300 REM********		PRINT OUT BOARD
    //********		print out board
    // 03310 GOSUB 5159
    Routine_05159();
    // 03320 REM********		TEST FOR END OF GAME
    //********		test for end of game
    // 03330 IF C1 = 0 THEN 3370
    if(C1_int==0) goto Lbl_03370;
    // 03340 IF N1 = 64 THEN 3370
    if(N1_int==64) goto Lbl_03370;
    // 03350 GO TO 2010
    goto Lbl_02010;
    // 03360 REM********		END OF GAME ; WRAPUP
    //********		end of game ; wrapup

  Lbl_03370:
    // 03370 LET L = 18
    L_int = 18;
    // 03380 GOSUB 5340
    Routine_05340();
    // 03390 PRINT "FOR RESULTS ON GAME TYPE RETURN!!"
    MyFpf(stdout,"for results on game type return!!\n");
    // 03400 INPUT X$
    // Start of Basic INPUT statement 03400
    printf(" ? ");
    char inpbuf_03400[100];
    if(fgets(inpbuf_03400,100,stdin)==NULL){
        fprintf(stderr,"ERROR: End of file on input.\n");
        exit(2);
    }else{
        // This may cause problems if BASIC programmer expected
        // input strings to be copied instead of just pointing
        // to the input buffer (ie. strings can be over written).
        char *ps_03400=strtok(inpbuf_03400," ,\t\n");
        if(ps_03400==NULL){
            X_str = "";
        }else{
            X_str = ps_03400;
        };
    }; // End of Basic INPUT statement 03400
    // 03410 PRINT CHR$(30),CHR$(26)
    MyFpf(stdout,"%s@%s\n",CHR_str(30),CHR_str(26));
    // 03420 PRINT "YOU HAVE ";
    MyFpf(stdout,"you have ");
    // 03430 PRINT H1;
    MyFpf(stdout,"%d",H1_int);
    // 03440 PRINT " PIECES, AND I HAVE ";
    MyFpf(stdout," pieces, and i have ");
    // 03450 PRINT C1;
    MyFpf(stdout,"%d",C1_int);
    // 03460 PRINT " PIECES--- "
    MyFpf(stdout," pieces--- \n");
    // 03470 IF H1 = C1 THEN 3510
    if(H1_int==C1_int) goto Lbl_03510;
    // 03480 IF H1 > C1 THEN 3530
    if(H1_int>C1_int) goto Lbl_03530;
    // 03490 PRINT "SORRY, I WON THAT ONE."
    MyFpf(stdout,"sorry, i won that one.\n");
    // 03500 GO TO 3540
    goto Lbl_03540;

  Lbl_03510:
    // 03510 PRINT " A TIE!!!!!"
    MyFpf(stdout," a tie!!!!!\n");
    // 03520 GO TO 3720
    goto Lbl_03720;

  Lbl_03530:
    // 03530 PRINT "YOU WON!!!"
    MyFpf(stdout,"you won!!!\n");

  Lbl_03540:
    // 03540 C1 = C1 - H1
    C1_int = C1_int-H1_int;
    // 03550 IF C1 > 0 THEN 3570
    if(C1_int>0) goto Lbl_03570;
    // 03560 C1 = -C1
    C1_int = -C1_int;

  Lbl_03570:
    // 03570 C1 = (64 * C1)/ N1
    C1_int = (64*C1_int)/N1_int;
    // 03580 PRINT "THAT WAS A ";
    MyFpf(stdout,"that was a ");
    // 03590 IF C1 < 11 THEN 3710
    if(C1_int<11) goto Lbl_03710;
    // 03600 IF C1 < 25 THEN 3690
    if(C1_int<25) goto Lbl_03690;
    // 03610 IF C1 < 39 THEN 3670
    if(C1_int<39) goto Lbl_03670;
    // 03620 IF C1 < 53 THEN 3650
    if(C1_int<53) goto Lbl_03650;
    // 03630 PRINT " A PERFECT GAME!"
    MyFpf(stdout," a perfect game!\n");
    // 03640 GO TO 3720
    goto Lbl_03720;

  Lbl_03650:
    // 03650 PRINT "WALKAWAY!"
    MyFpf(stdout,"walkaway!\n");
    // 03660 GO TO 3720
    goto Lbl_03720;

  Lbl_03670:
    // 03670 PRINT "FIGHT!"
    MyFpf(stdout,"fight!\n");
    // 03680 GO TO 3720
    goto Lbl_03720;

  Lbl_03690:
    // 03690 PRINT "HOT GAME!"
    MyFpf(stdout,"hot game!\n");
    // 03700 GO TO 3720
    goto Lbl_03720;

  Lbl_03710:
    // 03710 PRINT "SQUEAKER!"
    MyFpf(stdout,"squeaker!\n");

  Lbl_03720:
    // 03720 PRINT
    MyFpf(stdout,"\n");
    // 03730 PRINT"DO YOU WANT TO PLAY AGAIN";
    MyFpf(stdout,"do you want to play again");

  Lbl_03740:
    // 03740 INPUT X$
    // Start of Basic INPUT statement 03740
    printf(" ? ");
    char inpbuf_03740[100];
    if(fgets(inpbuf_03740,100,stdin)==NULL){
        fprintf(stderr,"ERROR: End of file on input.\n");
        exit(2);
    }else{
        // This may cause problems if BASIC programmer expected
        // input strings to be copied instead of just pointing
        // to the input buffer (ie. strings can be over written).
        char *ps_03740=strtok(inpbuf_03740," ,\t\n");
        if(ps_03740==NULL){
            X_str = "";
        }else{
            X_str = ps_03740;
        };
    }; // End of Basic INPUT statement 03740
    // 03750 IF X$ = "Y" THEN 1700
    if(strcmp(X_str,"y")==0) goto Lbl_01700;
    // 03760 IF X$ <> "N" THEN 3740
    if(strcmp(X_str,"n")!=0) goto Lbl_03740;
    // 03770 PRINT "THANKS FOR PLAYING."
    MyFpf(stdout,"thanks for playing.\n");
    // 03780 STOP
    exit(1);
    // 04620 END
};

//---------------------------------------------------------------------------
// End of $RCSfile: Othelo.cpp,v $ 
//---------------------------------------------------------------------------
